/***************************************************************************/
/* 		This code is part of WWW graber called pavuk		   */
/*		Copyright (c) 1997,1998,1999 Ondrejicka Stefan		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#ifndef _http_h_
#define _http_h_

#include <time.h>
#include "url.h"
#include "bufio.h"

#define DEFAULT_HTTP_PORT	80
#define DEFAULT_HTTP_PROXY_PORT	8080
#define DEFAULT_SSL_PORT	443
#define DEFAULT_SSL_PROXY_PORT	8080

typedef struct {
	char	version[4];	/*** verzia HTTP protokolu z navratoveho kodu ***/
	int	ret_code;	/*** cislo navratoveho kodu ***/
	char	*text;		/*** textova informacia k navratovemu kodu ***/
} http_response;

#if NeedFunctionPrototypes
extern int http_connect(char * , int);
extern int http_get_reguest(bufio * , url * , int , struct tm *);
extern bufio *get_http_data_socket(url * , int , struct tm *);
extern http_response * get_response(char *);
extern int read_mime_header(bufio * , char ** , int *);
extern int http_dumy_proxy_connect(bufio * , char * , int);
#else
extern int http_connect();
extern int http_get_reguest();
extern bufio *get_http_data_socket();
extern http_response * get_response();
extern int read_mime_header();
extern int http_dumy_proxy_connect();
#endif

#endif
