/***************************************************************************/
/* 		This code is part of WWW graber called pavuk		   */
/*		Copyright (c) 1997,1998,1999 Ondrejicka Stefan		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <netdb.h>
#include <errno.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <limits.h>
#include <time.h>

#include "config.h"
#include "url.h"
#include "doc.h"
#include "tools.h"
#include "html.h"
#include "http.h"
#include "abstract.h"
#include "recurse.h"
#include "mime.h"
#include "robots.h"
#include "mode.h"
#include "times.h"


#ifdef I_FACE
#define SETNEXTURL	urlr->status |= URL_PROCESSED;\
			if (cfg.xi_face)\
				icons_set_for_doc(&docu);\
			_free(pstr);\
			_free(docu.mime);\
			_free(docu.type_str);\
			_free(docu.dtime);\
			_free(docu.contents);\
			_free(docu.etag);\
			cfg.auth_digest = FALSE;\
			_free(cfg.auth_realm);\
			_free(cfg.auth_nonce);\
			_free(cfg.auth_opaque);\
			return;
#else
#define SETNEXTURL	urlr->status |= URL_PROCESSED;\
			_free(pstr);\
			_free(docu.mime);\
			_free(docu.type_str);\
			_free(docu.dtime);\
			_free(docu.contents);\
			_free(docu.etag);\
			cfg.auth_digest = FALSE;\
			_free(cfg.auth_realm);\
			_free(cfg.auth_nonce);\
			_free(cfg.auth_opaque);\
			return;
#endif

void process_url(urlr , check_lim)
url *urlr;
int check_lim;
{
	doc docu;
	url **pom;
	int pokus = 0;
	int nreget=0 , nredir=0;
	time_t atm;
	char cpom[2048];

	char *pstr = NULL;
	char *pp = NULL;
	int store_stat;
	struct stat estat;

	docu.etag = NULL;

	cfg.auth_nonce = NULL;	
	cfg.auth_opaque = NULL;
	cfg.auth_realm = NULL;
	cfg.auth_digest = FALSE;

	pokus = 0;
	nredir = 0;
	nreget = 0;

	cfg.check_limits = check_lim;

	if (cfg.check_limits)
		cfg.check_limits = (urlr->parent_url[0] != NULL);

#ifdef I_FACE
	while (!cfg.stop)
#else
	while (TRUE)
#endif
	{
		cfg.errcode = ERR_NOERROR;
		cfg.totsz = 0;
		pstr = url_to_urlstr(urlr);
		docu.mime = NULL;
		docu.type_str = NULL;
		docu.doc_url = urlr;
		docu.dtime = NULL;
		docu.contents = NULL;

		if (pokus) xprintf(1 , gettext("retry nr. %d\n"),pokus);

#ifdef I_FACE
		if (cfg.xi_face)
		{
			sprintf(cpom , "%d/%d" , cfg.actual_url + 1, cfg.total_cnt);
			iface_set_counter(cpom);
		}
#endif
		xprintf(1 , gettext("URL: %5d of %5d  %s\n") , cfg.actual_url + 1, 
				cfg.total_cnt , pstr);

		if (check_lim)
		{
			if (urlr->status & URL_PROCESSED)
			{
				xprintf(1 , gettext("Allready processed\n"));
				SETNEXTURL;
			}

			if (urlr->status & URL_USER_DISABLED)
			{
				xprintf(1 , gettext("Disallowed by user\n"));
				SETNEXTURL;
			}


			if (!prottable[urlr->type].supported || 
			    (urlr->type == FTP && urlr->p.ftp.dir && !cfg.condition.ftpdir) ||
			    (urlr->parent_url[0] && !url_append_condition(urlr , FALSE)))
			{ 
				xprintf(1 , gettext("Disallowed by rules\n"));

				urlr->status |= URL_REJECTED;
				SETNEXTURL;
			}

#ifdef I_FACE
	         	if (cfg.xi_face)
			      	iface_set_what(gettext("Connecting"));
#endif
			cfg.report_size = FALSE;
			if (!check_robots(urlr))
			{
				xprintf(1 , gettext("Disallowed by \"robots.txt\"\n"));

				urlr->status |= URL_REJECTED;
				SETNEXTURL;
			}
		}
	
		cfg.report_size = TRUE;

#ifdef I_FACE
   	    	if (cfg.xi_face)
			iface_set_what(gettext("Transfering data"));
#endif

		if (cfg.mode == MODE_SYNC)
		{
			pp = url_to_filename(urlr);
			if (!stat(pp , &estat) && !S_ISDIR(estat.st_mode))
			{
				atm = time(NULL) - 86400 * cfg.ddays;
				if (estat.st_mtime < atm)
					docu.dtime = new_tm(gmtime(&estat.st_mtime));
				else
				{
					xprintf(1 , gettext("No transfer - file not expired\n"));

					_free(pp);
					urlr->status |= URL_REJECTED;
					SETNEXTURL;
				}
			}
			_free(pp);
		}

		if (cfg.show_time)
		{
			atm = time(NULL);
			strftime(cpom , sizeof(cpom) , "%H:%M:%S" , localtime(&atm));		
			xprintf(1 , gettext("Starting time :  %s\n") , cpom);
		}

#ifdef I_FACE
		if (!cfg.stop && !cfg.rbreak)
		{
#endif

		if (download_document(&docu,(cfg.prepurlstr && cfg.mode == MODE_SYNC)))
		{
			if (cfg.show_time)
			{
				atm = time(NULL);
				strftime(cpom , sizeof(cpom) , "%H:%M:%S" , localtime(&atm));
				xprintf(1 , gettext("Ending time :    %s\n") , cpom);
			}

			remove_lock();
			report_error(cfg.errcode , "download");
			_free(docu.contents);
			_free(docu.dtime);

			if (((nreget < cfg.nreget) &&
				(cfg.errcode == ERR_HTTP_TRUNC || cfg.errcode == ERR_FTP_TRUNC))
				|| (nredir < cfg.nredir && cfg.errcode == ERR_HTTP_REDIR)
				|| (cfg.errcode == ERR_HTTP_AUTH))
			{
				if (cfg.errcode == ERR_HTTP_REDIR)
				{
					if (urlr->moved_to->status & URL_PROCESSED)
					{
						SETNEXTURL;
					}
					else
					{
#ifdef I_FACE
						if (cfg.xi_face)
							icons_set_for_doc(&docu);
#endif
						urlr = urlr->moved_to;
					}
					cfg.auth_digest = FALSE;
					_free(cfg.auth_realm);
					_free(cfg.auth_nonce);
					_free(cfg.auth_opaque);
				}
				if (cfg.errcode == ERR_HTTP_TRUNC)
				{
					urlr->status |= URL_TRUNCATED;
					_free(docu.etag);

					docu.etag = get_mime_param_val_str("ETag:" , docu.mime);
					if (!docu.etag) docu.etag = get_mime_param_val_str("Last-Modified" , docu.mime);
				}

				if (cfg.errcode == ERR_HTTP_AUTH && !cfg.auth_digest)
				{
					char *authtag = NULL;

					if ((authtag = get_mime_param_val_str("WWW-Authenticate:" , docu.mime)))
					{
						if (!strncmp(authtag , "Digest " , 7))
						{
							_free(cfg.auth_realm);
							_free(cfg.auth_nonce);
							_free(cfg.auth_opaque);
							cfg.auth_realm = get_url_from_tag(authtag , "realm");
							cfg.auth_nonce = get_url_from_tag(authtag , "nonce");
							cfg.auth_opaque = get_url_from_tag(authtag , "opaque");
							cfg.auth_digest = TRUE;
						}
						else
						{
							_free(authtag);
							urlr->status |= URL_ERR_REC;
							SETNEXTURL;
						}
					}
					else 
					{
						cfg.auth_digest = FALSE;
						_free(cfg.auth_realm);
						_free(cfg.auth_nonce);
						_free(cfg.auth_opaque);
						urlr->status |= URL_ERR_REC;
						SETNEXTURL;
					}
					_free(authtag);
				}
				else if (cfg.auth_digest)
				{
					cfg.auth_digest = FALSE;
					_free(cfg.auth_realm);
					_free(cfg.auth_nonce);
					_free(cfg.auth_opaque);
					urlr->status |= URL_ERR_REC;
					SETNEXTURL;
				}

				_free(docu.mime);
				_free(docu.type_str);

				nreget += (cfg.errcode == ERR_HTTP_TRUNC || 
					   cfg.errcode == ERR_FTP_TRUNC) &&
					   cfg.mode != MODE_SREGET;
				nredir +=  cfg.errcode == ERR_HTTP_REDIR;
				_free(pstr);
				continue;
			}

			if (cfg.errcode == ERR_FTP_UNKNOWN ||
			    cfg.errcode == ERR_FTP_CONNECT ||
			    cfg.errcode == ERR_FTP_DATACON ||
			    cfg.errcode == ERR_HTTP_UNKNOWN ||
			    cfg.errcode == ERR_HTTP_CONNECT ||
			    cfg.errcode == ERR_HTTP_SNDREQ ||
			    cfg.errcode == ERR_HTTP_SERV ||
			    cfg.errcode == ERR_READ ||
			    cfg.errcode == ERR_GOPHER_CONNECT)
			{
				urlr->status |= URL_ERR_REC;
				pokus ++;
				/*** novy pokus len ak to ma zmysel !!!! ***/
				if (pokus >= cfg.nretry)
				{
					SETNEXTURL;
				}
				_free(pstr);
				_free(docu.mime);
				_free(docu.type_str);
				continue;
			}
			else if (cfg.errcode == ERR_BIGGER || cfg.errcode == ERR_LOCKED ||
				 cfg.errcode == ERR_NOMIMET || cfg.errcode == ERR_OUTTIME ||
				 cfg.errcode == ERR_SCRIPT_DISABLED)
			{
				urlr->status |= URL_ERR_REC;
				SETNEXTURL;

			}
			else
			{
				/*** remove improper documents if required ***/
				if ((cfg.remove_old && cfg.mode == MODE_SYNC) &&
				    (((cfg.errcode == ERR_FTP_GET ||
				     cfg.errcode == ERR_FTP_BDIR ||
				     cfg.errcode == ERR_FTP_NODIR) && 
				     	cfg.ftp_respc == 550) ||
				     cfg.errcode == ERR_HTTP_NFOUND))
				{
					remove_document(docu.doc_url);
				}

				cfg.fail_cnt++;

				urlr->status |= URL_ERR_UNREC;

				SETNEXTURL;
			}
		}

		if (urlr->status & URL_TRUNCATED)
			urlr->status &= ~URL_TRUNCATED;

		if (urlr->status & URL_ERR_REC)
			urlr->status &= ~URL_ERR_REC;
		

		if (cfg.recv_cookies && docu.mime)
		{
			int i;
			char *cookie_field;

			for (i = 0 ; (cookie_field = get_mime_n_param_val_str("Set-Cookie:" , docu.mime , i)) ; i++)
			{
				cookie_insert_field(cookie_field , urlr);
				_free(cookie_field);
			}
		}

		if (cfg.update_cookies && cfg.cookie_changed > 10)
		{
			cookie_update_ns();
		}
		
		if (cfg.show_time)
		{
			atm = time(NULL);
			strftime(cpom , sizeof(cpom) , "%H:%M:%S" , localtime(&atm));
			xprintf(1 , gettext("Ending time :    %s\n") , cpom);
		}

		report_error(cfg.errcode,"download");		

		if (docu.contents)
		{
			if (docu.is_html)
			{
				int len;
				char *newcont;
#ifdef I_FACE
    				if (cfg.xi_face)
					iface_set_what(gettext("Searching for links"));
#endif
				if (cfg.rewrite_links)
					relocate_html_doc(&docu);

				_Xt_Serve

				if (cfg.mode != MODE_SREGET && cfg.mode != MODE_RESUME)
				{
					pom = html_get_all_links(&docu ,
						cfg.mode == MODE_SINGLE);

#ifdef X_FACE
#ifdef WITH_TREE
					if (cfg.xi_face)
						TreeListDontDoLayout(cfg.X.tree_widget);
#endif
#endif
					cat_links_to_url_list(pom);
#ifdef X_FACE
#ifdef WITH_TREE
					if (cfg.xi_face)
						TreeListDoLayout(cfg.X.tree_widget);
#endif
#endif
				}

				if (cfg.rewrite_links)
				{
					len = html_remote_to_local_links(&newcont , &docu);
					_free(docu.contents);
					docu.contents = newcont;
					docu.size = len;
				}
			}
			store_stat = 0;

			if ((docu.doc_url->type != FILET) && !(docu.doc_url->status & URL_REDIRECT) && (cfg.mode != MODE_NOSTORE))
			{
#ifdef I_FACE
	       		 	if (cfg.xi_face)
				      	iface_set_what(gettext("Storing"));
#endif
				store_stat = store_document(&docu,TRUE);

				if (store_stat)
					xprintf(1 , gettext("Store failed\n"));
			}

			remove_lock();

			if ((docu.doc_url->type !=  FILET) && !(docu.doc_url->status & URL_REDIRECT) 
				&& (cfg.mode != MODE_NOSTORE) && docu.doc_url->parent_url)
			{
				if (cfg.rewrite_links && !store_stat)
				{
#ifdef I_FACE
	       			 	if (cfg.xi_face)
					      	iface_set_what(gettext("Rewriting links"));
#endif
					rewrite_parents_links(docu.doc_url , NULL);
				}
			}
		}
		else
		{

			remove_lock();
			if (cfg.rewrite_links && (cfg.mode != MODE_NOSTORE) &&
				(docu.doc_url->type !=  FILET) && 
				docu.doc_url->parent_url)
			{
#ifdef I_FACE
				if (cfg.xi_face)
					iface_set_what(gettext("Rewriting links"));
#endif
				rewrite_parents_links(docu.doc_url , NULL);
			}
		}

		urlr->status |= URL_DOWNLOADED;
		SETNEXTURL;
#ifdef I_FACE
	}
#endif
	}
}


/*********************************************/
/* rekurzivne prechadzanie stromu dokumentov */
/*********************************************/

void recurse()
{

	if (cfg.urlstack == NULL) return ;

	cfg.ftp_control = NULL;
	cfg.s_sock = NULL;

/**** obsluzenie vsetkych URL v zozname ****/
#ifdef I_FACE
	while(cfg.urlstack[cfg.actual_url] && !cfg.stop)
#else
	while(cfg.urlstack[cfg.actual_url])
#endif
	{
		process_url(cfg.urlstack[cfg.actual_url] , TRUE);
#ifdef I_FACE
		if (!cfg.rbreak) 
#endif
			cfg.actual_url++;
	}
#ifdef I_FACE
        if (cfg.xi_face)
        {
		char cpom[2048];

		if (cfg.rbreak)
		{
			cfg.actual_url --;
		}
		iface_set_what(gettext("Done"));
		sprintf(cpom , "%d/%d" , cfg.actual_url , cfg.total_cnt);
		iface_set_counter(cpom);
	}
#endif
	/**** uzatvorenie FTP spojenia ak bol preruseny prenos ****/
	if (cfg.ftp_control)
	{
                bufio_write(cfg.ftp_control , "QUIT\r\n" , 6);
                shutdown(bufio_getfd(cfg.ftp_control) , 2);
                bufio_close(cfg.ftp_control);
                cfg.ftp_control = 0;
	}

	if (cfg.update_cookies && cfg.cookie_changed)
	{
			cookie_update_ns();
	}

}

void get_urls_to_resume(dirname)
char *dirname;
{
	DIR *dir;
	struct dirent *dent;
	char next_dir[PATH_MAX];
	struct stat estat;
	url *purl;

	if (!(dir = opendir(dirname)))
	{
		xperror(dirname);
		return;
	}

	while((dent = readdir(dir)))
	{
		_Xt_Serve

		sprintf(next_dir , "%s/%s" , dirname , dent->d_name);
		if (!strcmp(dent->d_name , ".")) continue;
		if (!strcmp(dent->d_name , "..")) continue;		
		if (stat(next_dir , &estat))
		{
			xperror(next_dir);
			continue;
		}

		if (S_ISDIR(estat.st_mode))
		{
			get_urls_to_resume(next_dir);
		}
		else if (!strncmp(".in_" , dent->d_name , 4))
		{
			xprintf(1 , gettext("Adding %s to resume list\n") , next_dir);
			sprintf(next_dir , "%s/%s" , dirname , dent->d_name + 4);
			if ((purl = filename_to_url(next_dir)))
			{
				append_url_to_list(purl);
			}
		}

#ifdef I_FACE
		if (cfg.xi_face)
		{
			if (cfg.rbreak || cfg.stop)
			{
				closedir(dir);
				return;
			}
		}
#endif
	}

	closedir(dir);
}

void get_urls_to_synchronize(dirname)
char *dirname;
{
	DIR *dir;
	struct dirent *dent;
	char next_dir[PATH_MAX];
	struct stat estat;
	url *purl;


	if (!(dir = opendir(dirname)))
	{
		xperror(dirname);
		return;
	}

	while((dent = readdir(dir)))
	{
		_Xt_Serve

		sprintf(next_dir , "%s/%s" , dirname , dent->d_name);
		if (!strcmp(dent->d_name , ".")) continue;
		if (!strcmp(dent->d_name , "..")) continue;		
		if (stat(next_dir , &estat))
		{
			xperror(next_dir);
			continue;
		}

		if (S_ISDIR(estat.st_mode))
		{
			get_urls_to_synchronize(next_dir);
		}
		else if (!strncmp(".in_" , dent->d_name , 4))
		{
			xprintf(1 , gettext("Adding %s to sync list\n") , next_dir);
			sprintf(next_dir , "%s/%s" , dirname , dent->d_name + 4);
			if ((purl = filename_to_url(next_dir)))
			{
				append_url_to_list(purl);
			}
		}
		else
		{
			
			if ((purl = filename_to_url(next_dir)))
			{
				xprintf(1 , gettext("Adding %s to sync list\n") , next_dir);
				append_url_to_list(purl);
			}
		}

#ifdef I_FACE
		if (cfg.xi_face)
		{
			if (cfg.rbreak || cfg.stop)
			{
				closedir(dir);
				return;
			}
		}
#endif
	}

	closedir(dir);
}

