/***************************************************************************/
/* 		This code is part of WWW graber called pavuk		   */
/*		Copyright (c) 1997,1998,1999 Ondrejicka Stefan		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#include <time.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>

#include "config.h"
#include "tools.h"

typedef struct _dayn {
	char *name;
	int  dayn;
}dayn;

static dayn dnames[] = {
	{"Sun" , 0} ,
	{"Mon" , 1} ,
	{"Tue" , 2} ,
	{"Wed" , 3} ,
	{"Thu" , 4} ,
	{"Fri" , 5} ,
	{"Sat" , 6} ,
	{"Sunday" , 0} ,
	{"Monday" , 1} ,
	{"Tuesday" , 2} ,
	{"Wednesday" , 3} ,
	{"Thursday" , 4} ,
	{"Friday" , 5} ,
	{"Saturday" , 6} ,
};

static dayn mnames[] = {
	{"Jan" , 0} ,
	{"Feb" , 1} ,
	{"Mar" , 2} ,
	{"Apr" , 3} ,
	{"May" , 4} ,
	{"Jun" , 5} ,
	{"Jul" , 6} ,
	{"Aug" , 7} ,
	{"Sep" , 8} ,
	{"Oct" , 9} ,
	{"Nov" , 10} ,
	{"Dec" , 11} ,
	{"January" , 0} ,
	{"February" , 1} ,
	{"March" , 2} ,
	{"April" , 3} ,
	{"May" , 4} ,
	{"Jun" , 5} ,
	{"July" , 6} ,
	{"August" , 7},
	{"September" , 8} ,
	{"October" , 9} ,
	{"November" , 10} ,
	{"December" , 11} ,
};


/*******************/
/* kopia struct tm */
/*******************/
struct tm *new_tm(t)
struct tm *t;
{
	struct tm* tn = _malloc(sizeof(struct tm));
	memcpy((char *)tn , (char *)t , sizeof(struct tm));
	return tn;
}

struct tm *scntime(timestr)
char *timestr;
{
	char *pom = new_string(timestr);
	int i;
	char *p;
	static struct tm otm;

	otm.tm_isdst = -1;

	p = strtok(pom , ", -:");
	if (!p) return NULL;
	for (i = 0 ; i < NUM_ELEM(dnames) ; i++)
	{
		if (!strcasecmp(p , dnames[i].name))
		{
			otm.tm_wday = dnames[i].dayn;
			break;
		}
	}
	if (!(i < NUM_ELEM(dnames))) return NULL;

	p = strtok(NULL , ", -:");
	otm.tm_mday = _atoi(p);
	if (errno == ERANGE)
	{
		for(i = 0 ; i < NUM_ELEM(mnames) ; i++)
		{
			if (!strcasecmp(p , mnames[i].name))
			{
				otm.tm_mon = mnames[i].dayn;
				break;
			}
		}
		if (!(i < NUM_ELEM(mnames))) return NULL;

		p = strtok(NULL , ", -:");
		otm.tm_mday = _atoi(p);
		if (errno == ERANGE) return NULL;

		p = strtok(NULL , ", -:");
		otm.tm_hour = _atoi(p);
		if (errno == ERANGE) return NULL;

		p = strtok(NULL , ", -:");
		otm.tm_min = _atoi(p);
		if (errno == ERANGE) return NULL;

		p = strtok(NULL , ", -:");
		otm.tm_sec = _atoi(p);
		if (errno == ERANGE) return NULL;

		p = strtok(NULL , ", -:");
		otm.tm_year = _atoi(p);
		if (errno == ERANGE) return NULL;
		otm.tm_year = (otm.tm_year > 1900) ? otm.tm_year - 1900 : otm.tm_year;
	}
	else
	{
		p = strtok(NULL , ", -:");

		for(i = 0 ; i < NUM_ELEM(mnames) ; i++)
		{
			if (!strcasecmp(p , mnames[i].name))
			{
				otm.tm_mon = mnames[i].dayn;
				break;
			}
		}
		if (!(i < NUM_ELEM(mnames))) return NULL;

		p = strtok(NULL , ", -:");
		otm.tm_year = _atoi(p);
		if (errno == ERANGE) return NULL;
		otm.tm_year = (otm.tm_year > 1900) ? otm.tm_year - 1900 : otm.tm_year;

		p = strtok(NULL , ", -:");
		otm.tm_hour = _atoi(p);
		if (errno == ERANGE) return NULL;

		p = strtok(NULL , ", -:");
		otm.tm_min = _atoi(p);
		if (errno == ERANGE) return NULL;

		p = strtok(NULL , ", -:");
		otm.tm_sec = _atoi(p);
		if (errno == ERANGE) return NULL;
	}

	free(pom);
	return &otm;
}

struct tm *time_ftp_scn(timestr)
char *timestr;
{
	char pom[10];
	struct tm ftm;

	ftm.tm_isdst = -1;
	strncpy(pom , timestr , 4);
	*(pom + 4) = '\0';
	ftm.tm_year = _atoi(pom) - 1900;

	strncpy(pom , timestr + 4 , 2);
	*(pom + 2) = '\0';
	ftm.tm_mon = _atoi(pom) - 1;

	strncpy(pom , timestr + 6 , 2);
	*(pom + 2) = '\0';
	ftm.tm_mday = _atoi(pom);

	strncpy(pom , timestr + 8 , 2);
	*(pom + 2) = '\0';
	ftm.tm_hour = _atoi(pom);

	strncpy(pom , timestr + 10 , 2);
	*(pom + 2) = '\0';
	ftm.tm_min = _atoi(pom);

	strncpy(pom , timestr + 12 , 2);
	*(pom + 2) = '\0';
	ftm.tm_sec = _atoi(pom);

	return new_tm(&ftm);
}

time_t time_scn_cmd(timestr)
char *timestr;
{
	time_t t = 0;
	struct tm ftm;

	if (sscanf(timestr , "%d.%d.%d.%d:%d" , &ftm.tm_year , &ftm.tm_mon ,
			&ftm.tm_mday , &ftm.tm_hour , &ftm.tm_min) == 5)
	{
		ftm.tm_year = ftm.tm_year - 1900;
		ftm.tm_mon -= 1;
		ftm.tm_isdst = -1;
		t = mktime(&ftm);
	}

	return t;
}

