/***************************************************************************/
/* 		This code is part of WWW graber called pavuk		   */
/*		Copyright (c) 1997,1998,1999 Ondrejicka Stefan		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>
#include <limits.h>
#include <sys/types.h>
#include <dirent.h>
#include <signal.h>

#include "config.h"

#ifdef X_FACE
#include <Nws/Nws.h>
#include <X11/Shell.h>

#include <X11/xpm.h>

#include "uconfig.h"
#include "recurse.h"
#include "url.h"
#include "schedule.h"
#include "tools.h"
#include "update_links.h"
#include "mode.h"
#include "ainterface.h"
#include "appdef.h"
#include "html.h"

#include "sema.xpm"
#include "rest.xpm"
#include "brk.xpm"
#include "backg.xpm"
#include "stop.xpm"
#include "clk.xpm"
#include "cfgp.xpm"
#include "kill.xpm"
#include "pavuk_logo.xpm"

#include "lang.h"
#include "mimetype.h"

typedef struct _ListOpRec {
	Widget		entryw;
	Widget		listw;
	char		***list;
} ListOpRec;

static char *en_month_names[] = {
	gettext_nop("January") ,
	gettext_nop("February") ,
	gettext_nop("March") ,
	gettext_nop("April") ,
	gettext_nop("May") ,
	gettext_nop("Jun") ,
	gettext_nop("July") ,
	gettext_nop("August") ,
	gettext_nop("September") ,
	gettext_nop("October") ,
	gettext_nop("November") ,
	gettext_nop("December")
};

static void SwitchMode(gr , w , data)
ToggleGroup *gr;
Widget w;
XtPointer data;
{
	XtVaGetValues(w , XtNwid , &cfg.mode , NULL);
	if (cfg.done && cfg.mode_started)
	{
		if (cfg.mode != cfg.prev_mode)
		{
			XtSetSensitive(cfg.X.bt_start,FALSE);
		}
		else
		{
			XtSetSensitive(cfg.X.bt_start,TRUE);
		}
	}
}

static void Gobg(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	cfg.xi_face = FALSE;
	cfg.stop = True;
	XtCloseDisplay(cfg.X.dpy);
}

static void DeleteFromList(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	ListOpRec *info = (ListOpRec *) client_data;
	ListStruct *l = ListGetSelected(info->listw);

	if (l)
	{
		DeleteListItem(info->listw , l->index);
	}
	else XBell(cfg.X.dpy , 50);
}

static void AppendToList(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	ListOpRec *info = (ListOpRec *) client_data;
	ListStruct plist;

       	plist.sensitive = True;
  	plist.left_icon = NULL;
  	plist.right_icon = NULL;
  	plist.related_info = NULL;
	plist.label = EntryLineGetText(info->entryw);

	if (plist.label && strlen(plist.label))
	{
		ListAppendItems(info->listw , &plist , 1);
	}
	else XBell(cfg.X.dpy , 50);
}

static void DeleteFromLangList(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	ListStruct *l = ListGetSelected(cfg.X.langlist);

	if (l)
	{
		DeleteListItem(cfg.X.langlist , l->index);
	}
	else XBell(cfg.X.dpy , 50);
}

static void AppendToLangList(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	ListStruct plist,*lp;
	char pom[3] = {'\0','\0','\0'};

	lp = ListGetSelected(cfg.X.alanglist);
	if (!lp)
	{
		XBell(cfg.X.dpy , 50);
		return;
	}
	
       	plist.sensitive = True;
  	plist.left_icon = NULL;
  	plist.right_icon = NULL;
  	plist.related_info = NULL;
	plist.label = pom;
	strncpy(pom , lp->label , 2);

	if (plist.label && strlen(plist.label))
	{
		ListAppendItems(cfg.X.langlist , &plist , 1);
	}
	else XBell(cfg.X.dpy , 50);
}

static void DeleteFromMIMEList(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	ListStruct *l = ListGetSelected(cfg.X.amimelist);

	if (l)
	{
		DeleteListItem(cfg.X.amimelist , l->index);
	}
	else XBell(cfg.X.dpy , 50);
}

static void AppendToMIMEList(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	ListStruct plist,*lp;

	lp = ListGetSelected(cfg.X.mimelist);
	if (!lp)
	{
		XBell(cfg.X.dpy , 50);
		return;
	}
	
       	plist.sensitive = True;
  	plist.left_icon = NULL;
  	plist.right_icon = NULL;
  	plist.related_info = NULL;
	plist.label = lp->label;

	if (plist.label && strlen(plist.label))
	{
		ListAppendItems(cfg.X.amimelist , &plist , 1);
	}
	else XBell(cfg.X.dpy , 50);
}

static void CalendarMonth(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	static struct tm *t;
	ListStruct *ls;

	XtVaGetValues((Widget)client_data , XtNtime , &t , NULL);

	ls = ListGetSelected(ComboGetListWidget(w));

	t->tm_mon = ls->index;
	
	XtVaSetValues((Widget)client_data,XtNtime,t,NULL);
}

static void CalendarYear(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	static struct tm *t;

	XtVaGetValues((Widget)client_data , XtNtime , &t , NULL);

	t->tm_year = NumberEntryGetValue(w);

	XtVaSetValues((Widget)client_data ,XtNtime,t,NULL);
}

static void ClearLog(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	LogClear(cfg.X.logw);
}

static void OpenURL(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	CardBoxSwitchTo(cfg.X.cb_comcfg , 0);
}

static void Quit(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	if (cfg.dns_pid)
		kill(cfg.dns_pid , 15); /* terminate dns resolver */

        exit(0);
}

static void PopupW(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	XtPopup((Widget)client_data , XtGrabExclusive);
}

static void PopupNoW(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	XtPopup((Widget)client_data , XtGrabNone);
}

static void PopupWC(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	XtPopup((Widget)client_data , XtGrabExclusive);
	if ((Widget)client_data == cfg.X.config_shell)
		xset_cfg_values_comm();
	else if ((Widget)client_data == cfg.X.cfg_limits)
		xset_cfg_values_lim();
}

static void PopdownW(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	XtPopdown((Widget)client_data);
}

static void Start(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	if (cfg.processing)
	{
		XBell(cfg.X.dpy , 50);
		return;
	}

	XtSetSensitive(cfg.X.mbb_cfg , FALSE);
	XtSetSensitive(cfg.X.mbb_mode , FALSE);
	XtSetSensitive(cfg.X.bt_cfg,FALSE);
	XtSetSensitive(cfg.X.bt_rest,FALSE);
	XtSetSensitive(cfg.X.bt_start,FALSE);
	XtSetSensitive(cfg.X.bt_stop,TRUE);
#ifdef WITH_TREE
	LabelSetLabel(cfg.X.tree_help , "");
#endif
	XtSetSensitive(cfg.X.me_surl,FALSE);
	XtSetSensitive(cfg.X.me_sch,FALSE);
	XtSetSensitive(cfg.X.bt_break,TRUE);
	XtSetSensitive(cfg.X.scn_lme,FALSE);
	XtSetSensitive(cfg.X.scn_sme,FALSE);

	cfg.processing = TRUE;

	if (client_data || cfg.mode != cfg.prev_mode || !cfg.mode_started)
	{
		absi_restart();
	}
	else
	{
		absi_cont();
	}

	cfg.processing = FALSE;

	XBell(cfg.X.dpy , 50);

	XtSetSensitive(cfg.X.mbb_cfg , TRUE);
	XtSetSensitive(cfg.X.mbb_mode , TRUE);
	XtSetSensitive(cfg.X.bt_cfg,TRUE);
	XtSetSensitive(cfg.X.bt_rest,TRUE);
	if (cfg.stop) XtSetSensitive(cfg.X.bt_start,TRUE);
	XtSetSensitive(cfg.X.bt_stop,FALSE);

	XtSetSensitive(cfg.X.me_surl,TRUE);
	XtSetSensitive(cfg.X.me_sch,TRUE);
	XtSetSensitive(cfg.X.bt_break,FALSE);
	XtSetSensitive(cfg.X.scn_lme,TRUE);
	XtSetSensitive(cfg.X.scn_sme,TRUE);

	cfg.stop = FALSE;
	cfg.rbreak = FALSE;
}

static void Stop(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	cfg.stop = True;
}

static void Break(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	cfg.rbreak = True;
	cfg.stop = True;
	cfg.X.endloop = TRUE;

	_X_EscLoop();
}

static void DoConfig(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	int retv = 0;

	if ((Widget)client_data == cfg.X.config_shell)
		retv = xget_cfg_values_comm();
	else if ((Widget)client_data == cfg.X.cfg_limits)
		retv = xget_cfg_values_lim();

	if (!retv)
		XtPopdown((Widget) client_data);
	else XBell(cfg.X.dpy , 50);
}

#ifdef WITH_TREE
static void PopupMenu(w , client_data , event , ctd)
Widget w;
XtPointer client_data;
XEvent *event;
Boolean * ctd;
{
        Widget menu = (Widget) client_data;
        Position x,y;
        Dimension width , height ,
                dwidth = DisplayWidth(cfg.X.dpy , DefaultScreen(cfg.X.dpy)) ,
                dheight = DisplayHeight(cfg.X.dpy , DefaultScreen(cfg.X.dpy)) ;
	TreeList *item = TreeListGetSelectedItem(cfg.X.tree_widget);
	url *urlp;

	if (event->type != ButtonPress || event->xbutton.button != Button3) return;

        if (!XtIsRealized(menu))  XtRealizeWidget(menu); 

        XtVaGetValues(menu , XtNwidth , &width , XtNheight , &height , NULL);

        XtTranslateCoords((Widget) w , event->xbutton.x ,
		event->xbutton.y , &x ,&y);

        if ( (x + width) > dwidth ) x = dwidth - width;

        if ( (y + height ) > dheight ) y = y - height;

        if ( y < 0 ) y = 0;

        XtVaSetValues(menu,XtNx,x,XtNy,y,NULL);

	if (!item || !item->item->related_info)
	{
		XtSetSensitive(cfg.X.me_disable_url , FALSE);
		XtSetSensitive(cfg.X.me_enable_url , FALSE);
		XtSetSensitive(cfg.X.me_browse_url , FALSE);
		XtSetSensitive(cfg.X.me_prop_url , FALSE);
		XtSetSensitive(cfg.X.me_download_url , FALSE);
	}
	else
	{
		XtSetSensitive(cfg.X.me_browse_url , TRUE);
		XtSetSensitive(cfg.X.me_prop_url , TRUE);

		urlp = (url *)item->item->related_info;

		if (urlp->status & URL_PROCESSED && !(urlp->status & URL_USER_DISABLED))
		{
			XtSetSensitive(cfg.X.me_disable_url , FALSE);
			XtSetSensitive(cfg.X.me_enable_url , FALSE);
			XtSetSensitive(cfg.X.me_download_url , 
				(urlp->status & URL_REJECTED) || 
				(urlp->status & URL_TRUNCATED) ||
				(urlp->status & URL_ERR_REC));
		}
		else
		{
			XtSetSensitive(cfg.X.me_disable_url , 
				!(urlp->status & URL_USER_DISABLED));
			XtSetSensitive(cfg.X.me_enable_url , 
				(urlp->status & URL_USER_DISABLED));
			XtSetSensitive(cfg.X.me_download_url ,
				cfg.processing ? FALSE :
				!(urlp->status & URL_USER_DISABLED));
		}
	}

        XtPopupSpringLoaded(menu);
}

static void LaunchBrowser(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	TreeList *item = TreeListGetSelectedItem(cfg.X.tree_widget);
	char pom[2048];
	char *p;

	if (!cfg.browser || !item || !item->item->related_info)
	{
		XBell(cfg.X.dpy , 50);
		return;
	}

	p = url_to_filename((url *)item->item->related_info);

	if (access(p,R_OK))
	{
		free(p);
		p = url_to_urlstr((url *)item->item->related_info);
	}

	sprintf(pom , "%s %s &" , cfg.browser , p);
	system(pom);

	free(p);
}

static void Propert(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	TreeList *item = TreeListGetSelectedItem(cfg.X.tree_widget);
	char pom[2048];
	url_prop *prp;

	if (!item || !item->item->related_info)
	{
		XBell(cfg.X.dpy , 50);
		return;
	}
	
	prp = ((url *)item->item->related_info)->prop;

	if (!prp)
	{
		sprintf(pom , gettext("Not aviable"));
	}
	else
	{
		if (prp->type)
			sprintf(pom , gettext("Size : %d   Type : %s") , prp->size , prp->type);
		else
			sprintf(pom , gettext("Size : %d   Type : unknown") , prp->size);		
	}

	LabelSetLabel(cfg.X.tree_help , pom);
}

static void DisableURL(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	TreeList *item = TreeListGetSelectedItem(cfg.X.tree_widget);
	url *urlp;
	int i;

	if (!item || !item->item->related_info)
	{
		XBell(cfg.X.dpy , 50);
		return;
	}

	urlp = 	(url *)item->item->related_info;

	urlp->status |= URL_USER_DISABLED;

	for (i = 0 ; i < urlp->ref_cnt ; i++)
		TreeListItemSetSensitive(cfg.X.tree_widget , urlp->tree_nfo[i] , FALSE);
}

static void EnableURL(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	TreeList *item = TreeListGetSelectedItem(cfg.X.tree_widget);
	url *urlp;
	int i;

	if (!item || !item->item->related_info)
	{
		XBell(cfg.X.dpy , 50);
		return;
	}

	urlp = 	(url *)item->item->related_info;

	urlp->status &= ~URL_USER_DISABLED;

	for (i = 0 ; i < urlp->ref_cnt ; i++)
		TreeListItemSetSensitive(cfg.X.tree_widget , urlp->tree_nfo[i] , TRUE);

	if (urlp->status & URL_PROCESSED)
	{
		urlp->status &= ~URL_PROCESSED;

		cfg.urlstack =_realloc(cfg.urlstack , 
			(cfg.total_cnt + 2) * sizeof(url *));
		cfg.urlstack[cfg.total_cnt] =  urlp;
		cfg.urlstack[cfg.total_cnt + 1] =  NULL;
		cfg.total_cnt++;
	}
}

static void DownloadThisURL(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	TreeList *item = TreeListGetSelectedItem(cfg.X.tree_widget);
	url *urlp;

	if (!item || !item->item->related_info)
	{
		XBell(cfg.X.dpy , 50);
		return;
	}

	urlp = 	(url *)item->item->related_info;

	cfg.rbreak = FALSE;
	cfg.stop = FALSE;

	cfg.processing = TRUE;

	process_url(urlp , FALSE);

	cfg.processing = FALSE;

	cfg.rbreak = FALSE;
	cfg.stop = FALSE;

	iface_set_what("Done");
}

static void ClrHlp(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	LabelSetLabel(cfg.X.tree_help , "");
}

#endif

void get_sch_cfg_values()
{

	cfg.time->tm_hour = NumberEntryGetValue(cfg.X.hour_label);
	cfg.time->tm_min = NumberEntryGetValue(cfg.X.min_label);
}

static void Schedule(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	get_sch_cfg_values();

	if (!at_schedule())
	{
		XtPopdown(cfg.X.cfg_sch);
		return;
	}
	xprintf(1 , gettext("Error scheduling\n"));
	XBell(cfg.X.dpy , 50);
}


static void ToggleBool(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	bool *v = (bool *) client_data;

	XtVaGetValues(w , XtNon , v , NULL);
}


static void PopupScenario(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	if (client_data)
		XtPopup(XtParent(cfg.X.scn_save_shell), XtGrabExclusive);
	else
		XtPopup(XtParent(cfg.X.scn_load_shell), XtGrabExclusive);
}

static void SaveScenario(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	char pom[PATH_MAX];
	char *p;
	char *d;

	XtVaGetValues(cfg.X.scn_save_shell , XtNfile , &p , NULL);
	XtVaGetValues(cfg.X.scn_save_shell , XtNdir , &d , NULL);

	if (p && *p)
	{
		sprintf(pom , "%s/%s" , d , p);
		if (cfg_dump(pom))
			XBell(cfg.X.dpy , 50);
		else
			XtPopdown(XtParent(cfg.X.scn_save_shell));
	}
	else XBell(cfg.X.dpy , 50);
}

static void LoadScenario(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
	char pom[PATH_MAX];
	char *p;
	char *d;

	XtVaGetValues(cfg.X.scn_load_shell , XtNfile , &p , NULL);
	XtVaGetValues(cfg.X.scn_load_shell , XtNdir , &d , NULL);

	if (p && *p)
	{
		sprintf(pom , "%s/%s" , d , p);

		if (cfg_load(pom))
			XBell(cfg.X.dpy , 50);
		else
		{
			ToggleGroupSetActive(cfg.X.modegr ,
				ToggleGetWidgetByWid(cfg.X.modegr , cfg.mode));

			XtSetSensitive(cfg.X.bt_start,FALSE);

			free_all();
			cfg.total_cnt = 0;
			cfg.urlstack = NULL;

			cfg.mode_started = FALSE;

			XtPopdown(XtParent(cfg.X.scn_load_shell));
		}
	}
	else XBell(cfg.X.dpy , 50);
}

static void build_scenario_loader(parent)
Widget parent;
{
	Widget fss,fs;
	
	CreateFSShell("dirsel_shell" , "dirsel" , parent , &fss , &fs);

	cfg.X.scn_load_shell = fs;

	XtDestroyWidget(GetFileSelWidget(fs , XtCapply_button));
	XtDestroyWidget(GetFileSelWidget(fs , XtChelp_button));

	if (cfg.scndir)
		XtVaSetValues(fs , XtNdir , cfg.scndir , NULL);

	XtAddCallback(fs , XtNok_button_cb , LoadScenario , (XtPointer) 0);
}

static void build_scenario_saver(parent)
Widget parent;
{
	Widget fs , fss;

	CreateFSShell("dirsel_shell" , "dirsel" , parent , &fss , &fs);

	cfg.X.scn_save_shell = fs;

	XtDestroyWidget(GetFileSelWidget(fs , XtCapply_button));
	XtDestroyWidget(GetFileSelWidget(fs , XtChelp_button));

	if (cfg.scndir)
		XtVaSetValues(fs , XtNdir , cfg.scndir , NULL);

	XtAddCallback(fs , XtNok_button_cb , SaveScenario , (XtPointer) 1);
}


static void build_tree_preview(parent)
Widget parent;
{
#ifdef WITH_TREE
	Widget col,but;

	cfg.X.tree_shell = XtVaCreatePopupShell("tree_shell", 
			topLevelShellWidgetClass , parent , NULL);

	col = XtVaCreateManagedWidget("tree_col" , colWidgetClass ,
		cfg.X.tree_shell , NULL);
		 
	cfg.X.tree_widget = GetTreeListWidget(XtVaCreateManagedWidget("url_tree" , 
		scrollTreeListWidgetClass , col , 
		XtNresizable , True , NULL));

	XtAddCallback(cfg.X.tree_widget , XtNselect_changed_cb , ClrHlp , NULL);

	cfg.X.tree_help = XtVaCreateManagedWidget("tree_help" , 
		labelWidgetClass , col ,
		XtNlabel , " " ,
		XtNwidth , 10,
		XtNtop_space , 5 ,
		XtNbottom_space , 5 ,		
		NULL);

	but = XtVaCreateManagedWidget("but_cancel" , buttonWidgetClass , col , 
		XtNright_space , 15 , 
		XtNgravitation , XtCright , NULL);

	XtAddCallback(but , XtNactivate , PopdownW , cfg.X.tree_shell);

	cfg.X.tmenu = XtVaCreatePopupShell ("tree_menu" , menuWidgetClass ,
		cfg.X.tree_widget , NULL);

        XtAddEventHandler(cfg.X.tree_widget , ButtonPressMask , 
                True , PopupMenu , (XtPointer)cfg.X.tmenu);

	cfg.X.me_browse_url = XtVaCreateManagedWidget ("me_launch" , labelMEObjectClass ,
		cfg.X.tmenu , NULL);

	XtAddCallback(cfg.X.me_browse_url , XtNactivate , LaunchBrowser , cfg.X.tree_shell);

	cfg.X.me_prop_url = XtVaCreateManagedWidget ("me_prop" , labelMEObjectClass ,
		cfg.X.tmenu , NULL);

	XtAddCallback(cfg.X.me_prop_url , XtNactivate , Propert , cfg.X.tree_shell);

	cfg.X.me_disable_url = XtVaCreateManagedWidget ("me_disable" , labelMEObjectClass ,
		cfg.X.tmenu , NULL);

	XtAddCallback(cfg.X.me_disable_url , XtNactivate , DisableURL , cfg.X.tree_shell);

	cfg.X.me_enable_url = XtVaCreateManagedWidget ("me_enable" , labelMEObjectClass ,
		cfg.X.tmenu , NULL);

	XtAddCallback(cfg.X.me_enable_url , XtNactivate , EnableURL , cfg.X.tree_shell);

	cfg.X.me_download_url = XtVaCreateManagedWidget ("me_download" , labelMEObjectClass ,
		cfg.X.tmenu , NULL);

	XtAddCallback(cfg.X.me_download_url , XtNactivate , DownloadThisURL , cfg.X.tree_shell);
#endif
}

static void build_about(parent)
Widget parent;
{
	Widget	col,but;
	Icon *icon;
	char pom[1024];

	cfg.X.about_shell = XtVaCreatePopupShell("about_shell", 
			topLevelShellWidgetClass , parent , NULL);

	col = XtVaCreateManagedWidget("dumy_col" , colWidgetClass ,
		cfg.X.about_shell , NULL);

	icon = X_XpmDataToIcon(cfg.X.dpy , pavuk_logo_xpm);

	sprintf(pom , gettext("Pavuk %s\n \nan automatic WEB file graber\n \nBy Ondrejicka Stefan\n \n(ondrej@idata.sk)\n ") , VERSION);

	XtVaCreateManagedWidget("about_label" , labelWidgetClass , col ,
		XtNlabel , pom ,
		XtNicon , icon ,
		XtNicon_justify , XtCright ,
		XtNresizable , True , NULL);

	but = XtVaCreateManagedWidget("but_cancel" , buttonWidgetClass , col , 
		XtNright_space , 15 , 
		XtNgravitation , XtCright ,
		NULL);

	XtAddCallback(but , XtNactivate , PopdownW , cfg.X.about_shell);
}

static void build_menu(parent)
Widget parent;
{
	Widget mbar,fmenu,mbb,m_entry;

	mbar = XtVaCreateManagedWidget("mbar" , menuBarWidgetClass , parent , NULL);

	mbb = XtVaCreateManagedWidget("mb_file" , mBButtonObjectClass , mbar ,
		XtNmenu_name , "menu_file" , NULL);

#ifdef WITH_TREE
	mbb = XtVaCreateManagedWidget("mb_view" , mBButtonObjectClass , mbar ,
		XtNmenu_name , "menu_view" , NULL);
#endif

	cfg.X.mbb_mode = XtVaCreateManagedWidget("mb_mode" , mBButtonObjectClass , mbar ,
		XtNmenu_name , "menu_mode" , NULL);

	cfg.X.mbb_cfg = XtVaCreateManagedWidget("mb_cfg" , mBButtonObjectClass , mbar ,
		XtNmenu_name , "menu_cfg" , NULL);

	mbb = XtVaCreateManagedWidget("mb_help" , mBButtonObjectClass , mbar ,
		XtNmenu_name , "menu_help" , 
		XtNgravitation , XtCright ,
		NULL);

/*** FILE menu ***/
	fmenu = XtVaCreatePopupShell ("menu_file" , menuWidgetClass , mbar , NULL);

	cfg.X.me_surl = m_entry = XtVaCreateManagedWidget ("me_url" , labelMEObjectClass ,
			fmenu , NULL);

	XtAddCallback(m_entry , XtNactivate , PopupWC , cfg.X.config_shell);
	XtAddCallback(m_entry , XtNactivate , OpenURL , NULL);

	cfg.X.me_sch = m_entry = XtVaCreateManagedWidget ("me_sch" , labelMEObjectClass ,
			fmenu , NULL);

	XtAddCallback(m_entry , XtNactivate , PopupW , cfg.X.cfg_sch);

	XtVaCreateManagedWidget("line" , lineMEObjectClass , fmenu , NULL);
	
	cfg.X.scn_lme = m_entry = XtVaCreateManagedWidget ("me_scn_load" , labelMEObjectClass ,
			fmenu , NULL);

	XtAddCallback(m_entry , XtNactivate , PopupScenario , (XtPointer)0);

	cfg.X.scn_sme = m_entry = XtVaCreateManagedWidget ("me_scn_save" , labelMEObjectClass ,
			fmenu , NULL);

	XtAddCallback(m_entry , XtNactivate , PopupScenario , (XtPointer)1);

	XtVaCreateManagedWidget("line" , lineMEObjectClass , fmenu , NULL);

	m_entry = XtVaCreateManagedWidget ("me_quit" , labelMEObjectClass ,
			fmenu , NULL);

	XtAddCallback(m_entry , XtNactivate , Quit , NULL);
	
	
/*** CONFIG menu ***/
	fmenu = XtVaCreatePopupShell ("menu_cfg" , menuWidgetClass , parent , NULL);

	m_entry = XtVaCreateManagedWidget ("me_cfg_comm" , labelMEObjectClass ,
			fmenu , NULL);

	XtAddCallback(m_entry , XtNactivate , PopupWC , cfg.X.config_shell);

	m_entry = XtVaCreateManagedWidget ("me_cfg_lim" , labelMEObjectClass ,
			fmenu , NULL);

	XtAddCallback(m_entry , XtNactivate , PopupWC , cfg.X.cfg_limits);

	XtVaCreateManagedWidget("line" , lineMEObjectClass , fmenu , NULL);

#ifdef DEBUG
	m_entry = XtVaCreateManagedWidget ("me_cfg_debug" , checkMEObjectClass ,
			fmenu , XtNon , cfg.debug , NULL);

	XtAddCallback(m_entry , XtNswitch , ToggleBool , &cfg.debug);
#endif

	m_entry = XtVaCreateManagedWidget ("me_cfg_quiet" , checkMEObjectClass ,
			fmenu , XtNon , cfg.quiet , NULL);

	XtAddCallback(m_entry , XtNswitch , ToggleBool , &cfg.quiet);

/*** MODE menu ***/
	cfg.X.modegr = CreateToggleGroup();
	ToggleAddCallback(cfg.X.modegr , SwitchMode , NULL);

	fmenu = XtVaCreatePopupShell ("menu_mode" , menuWidgetClass , mbar , NULL);

	m_entry = XtVaCreateManagedWidget ("me_normal" , checkMEObjectClass ,
			fmenu , XtNwid , MODE_NORMAL , NULL);
	AddWidgetToToggleGroup(cfg.X.modegr , m_entry);
	if (cfg.mode == MODE_NORMAL)
		ToggleGroupSetActive(cfg.X.modegr , m_entry);
	
	m_entry = XtVaCreateManagedWidget ("me_sync" , checkMEObjectClass ,
			fmenu , XtNwid , MODE_SYNC , NULL);
	AddWidgetToToggleGroup(cfg.X.modegr , m_entry);
	if (cfg.mode == MODE_SYNC)
		ToggleGroupSetActive(cfg.X.modegr , m_entry);

	m_entry = XtVaCreateManagedWidget ("me_spage" , checkMEObjectClass ,
			fmenu , XtNwid , MODE_SINGLE , NULL);
	AddWidgetToToggleGroup(cfg.X.modegr , m_entry);
	if (cfg.mode == MODE_SINGLE)
		ToggleGroupSetActive(cfg.X.modegr , m_entry);

	m_entry = XtVaCreateManagedWidget ("me_lnupd" , checkMEObjectClass ,
			fmenu , XtNwid , MODE_LNUPD , NULL);
	AddWidgetToToggleGroup(cfg.X.modegr , m_entry);
	if (cfg.mode == MODE_LNUPD)
		ToggleGroupSetActive(cfg.X.modegr , m_entry);

	m_entry = XtVaCreateManagedWidget ("me_resume" , checkMEObjectClass ,
			fmenu , XtNwid , MODE_RESUME , NULL);
	AddWidgetToToggleGroup(cfg.X.modegr , m_entry);
	if (cfg.mode == MODE_RESUME)
		ToggleGroupSetActive(cfg.X.modegr , m_entry);

	m_entry = XtVaCreateManagedWidget ("me_sreget" , checkMEObjectClass ,
			fmenu , XtNwid , MODE_SREGET , NULL);
	AddWidgetToToggleGroup(cfg.X.modegr , m_entry);
	if (cfg.mode == MODE_SREGET)
		ToggleGroupSetActive(cfg.X.modegr , m_entry);

	m_entry = XtVaCreateManagedWidget ("me_nostore" , checkMEObjectClass ,
			fmenu , XtNwid , MODE_NOSTORE , NULL);
	AddWidgetToToggleGroup(cfg.X.modegr , m_entry);
	if (cfg.mode == MODE_NOSTORE)
		ToggleGroupSetActive(cfg.X.modegr , m_entry);


/*** HELP menu ***/
	fmenu = XtVaCreatePopupShell ("menu_help" , menuWidgetClass , mbar , NULL);

	m_entry = XtVaCreateManagedWidget ("me_about" , labelMEObjectClass ,
			fmenu , NULL);

	XtAddCallback(m_entry , XtNactivate , PopupW , cfg.X.about_shell);
/*
	m_entry = XtVaCreateManagedWidget ("me_help" , labelMEObjectClass ,
			fmenu , NULL);
*/	
#ifdef WITH_TREE
	fmenu = XtVaCreatePopupShell ("menu_view" , menuWidgetClass , mbar , NULL);

	cfg.X.me_tree = m_entry = XtVaCreateManagedWidget ("me_tree" , labelMEObjectClass ,
			fmenu , NULL);

	XtAddCallback(m_entry , XtNactivate , PopupNoW , cfg.X.tree_shell);

	m_entry = XtVaCreateManagedWidget ("me_logclear" , labelMEObjectClass ,
			fmenu , NULL);

	XtAddCallback(m_entry , XtNactivate , ClearLog , NULL);

#endif
}

static Widget time_sel_new(parent , calendar , hentry , mentry , mcombo , yentry)
Widget parent;
Widget *calendar;
Widget *hentry;
Widget *mentry;
Widget *mcombo;
Widget *yentry;
{
	Widget col,pom2,cl;
	static ListStruct *lst = NULL;
	int i;

	col = XtVaCreateManagedWidget("cfg_col" , colWidgetClass , parent , NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , col , 
		XtNbox_width , 0 ,
		XtNbox_type , XtCno_box ,
		NULL);

	*mcombo = XtVaCreateManagedWidget("month_combo" , comboWidgetClass , pom2 , 
		XtNresizable , True , XtNeditable , False , NULL);

	cl = ComboGetListWidget(*mcombo);

	if (!lst)
	{
		lst = (ListStruct *) _malloc(12 * sizeof(ListStruct));
		for (i = 0 ; i < 12 ; i++)
		{
			lst[i].label = new_string(gettext(en_month_names[i]));
			lst[i].index = 0;
			lst[i].left_icon = None;
			lst[i].right_icon = None;
			lst[i].sensitive = True;
			lst[i].related_info = NULL;
		}
	}

	ListChange(cl , lst , 12 , FALSE);

	*yentry = XtVaCreateManagedWidget("year_entry" , numberEntryWidgetClass , pom2 ,
		XtNresizable , True , NULL);

	*calendar = XtVaCreateManagedWidget("calendar" , calendarWidgetClass , col ,
		NULL);

	XtAddCallback(*mcombo , XtNchange , CalendarMonth , 
		(XtPointer) *calendar);

	XtAddCallback(*yentry , XtNchange , CalendarYear , 
		(XtPointer) *calendar);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , col ,  
				XtNtop_space , 15 , NULL);

	XtVaCreateManagedWidget("time_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	*hentry = XtVaCreateManagedWidget("timed_label" , numberEntryWidgetClass ,
		pom2 ,
		XtNresizable , True ,
		XtNmaxval , 23 ,
		XtNwidth , 10 ,
		NULL);

	XtVaCreateManagedWidget("x_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box , XtNlabel , " : " ,
		NULL);

	*mentry = XtVaCreateManagedWidget("timed_label" , numberEntryWidgetClass ,
		pom2 ,
		XtNresizable , True ,
		XtNmaxval , 59 ,
		XtNwidth , 10 ,
		NULL);

	return col;
}

/**** SCHEDULER CFG ****/
static void build_config_sch(parent)
Widget parent;
{
	Widget col,cpar,but;
	Icon *icona;

	cfg.X.cfg_sch = XtVaCreatePopupShell("cfg_sche", topLevelShellWidgetClass , parent , NULL);

	col = time_sel_new(cfg.X.cfg_sch , &cfg.X.calendar , &cfg.X.hour_label ,
		&cfg.X.min_label ,
		&cfg.X.month , &cfg.X.year);

	cpar = XtVaCreateManagedWidget("dummy_row" , rowWidgetClass , col , NULL);

	XtVaCreateManagedWidget("resch_l1" , labelWidgetClass , cpar ,
		XtNbox_type , XtCno_box , NULL);

	cfg.X.resched = XtVaCreateManagedWidget("resch_t" , numberEntryWidgetClass , cpar ,
		XtNresizable , True , XtNvalue , cfg.reschedh , NULL);

	XtVaCreateManagedWidget("resch_l2" , labelWidgetClass , cpar ,
		XtNbox_type , XtCno_box , NULL);
	
	XtVaSetValues(cfg.X.calendar , XtNtime , (XtPointer)cfg.time, NULL);
	XtVaSetValues(cfg.X.year , XtNvalue , cfg.time->tm_year , NULL);
	ComboSetIndex(cfg.X.month , cfg.time->tm_mon);

	XtVaSetValues(cfg.X.hour_label , XtNvalue , cfg.time->tm_hour , NULL);
	XtVaSetValues(cfg.X.min_label , XtNvalue , cfg.time->tm_min , NULL);

	cpar = XtVaCreateManagedWidget("cfg_brow" , rowWidgetClass , col , NULL);

	icona = X_XpmDataToIcon(cfg.X.dpy , clk);

	but = XtVaCreateManagedWidget("but_ok" , buttonWidgetClass , cpar , 
		XtNleft_space , 15 ,
		XtNgravitation , XtCleft , 
		XtNlabel_justify , XtCcenter ,
		XtNicon_justify , XtCright ,
		XtNicon , icona , NULL);

	XtAddCallback(but , XtNactivate , Schedule , cfg.X.config_shell);

	but = XtVaCreateManagedWidget("but_cancel" , buttonWidgetClass , cpar , 
		XtNright_space , 15 , 
		XtNgravitation , XtCright , NULL);

	XtAddCallback(but , XtNactivate , PopdownW , cfg.X.cfg_sch);
	
}

/*** LIMITS CFG ***/
static void build_config_lim(parent)
Widget parent;
{
	Widget col,cpar,but,pom,pom2,cb,pom3;
	static ListOpRec hosts;
	static ListOpRec domains;
	static ListOpRec sfx;
	static ListOpRec prefix;
	static ListOpRec mimet;
	char *blabels[6];
	int i,j;

	blabels[0] = gettext("Tree");
	blabels[1] = gettext("Hosts");
	blabels[2] = gettext("Documents");
	blabels[3] = gettext("MIME types");
	blabels[4] = gettext("Time");
	blabels[5] = gettext("HTML");

	cfg.X.cfg_limits = XtVaCreatePopupShell("cfg_lim",
		topLevelShellWidgetClass , parent , NULL);
	
	col = XtVaCreateManagedWidget("cfg_col" , colWidgetClass ,
		cfg.X.cfg_limits , NULL);
	
	cb = XtVaCreateManagedWidget("card_box" ,cardBoxWidgetClass , col ,
		XtNbutton_labels , blabels , 
		XtNnumber_of_buttons , XtNumber(blabels),
		XtNresizable , True ,
		NULL);

	cpar = XtVaCreateManagedWidget("cfg_brow" , rowWidgetClass , col , NULL);

	but = XtVaCreateManagedWidget("but_ok" , buttonWidgetClass , cpar , 
		XtNleft_space , 15 ,
		XtNgravitation , XtCleft , NULL);

	XtAddCallback(but , XtNactivate , DoConfig , cfg.X.cfg_limits);

	but = XtVaCreateManagedWidget("but_cancel" , buttonWidgetClass , cpar , 
		XtNright_space , 15 , 
		XtNgravitation , XtCright , NULL);

	XtAddCallback(but , XtNactivate , PopdownW , cfg.X.cfg_limits);

/*** TREE ***/
	cpar = XtVaCreateManagedWidget("cfg_lim_row" , rowWidgetClass , cb ,
		XtNbox_width , 3 ,
		XtNbox_type , XtCno_box ,
		XtNheight , 10 ,
		XtNwidth , 10 ,
		XtNassociated_button , blabels[0] , NULL);

	pom = XtVaCreateManagedWidget("dumy_col" , colWidgetClass , cpar , 
			XtNresizable , True ,
			XtNbox_type , XtCno_box ,
			NULL);

	cfg.X.cgi_sw = XtVaCreateManagedWidget("cgi_switch" , 
		checkButtonWidgetClass , pom , 
		XtNon , cfg.condition.cgi ,
		NULL);

	cfg.X.ftpd_sw = XtVaCreateManagedWidget("ftpdir_switch" , 
		checkButtonWidgetClass , pom , 
		XtNon , cfg.condition.ftpdir ,
		NULL);

	cfg.X.robots_sw = XtVaCreateManagedWidget("robots_switch" , 
		checkButtonWidgetClass , pom , 
		XtNon , cfg.condition.allow_robots ,
		NULL);

	cfg.X.leaves_sw = XtVaCreateManagedWidget("leave_site" , 
		checkButtonWidgetClass , pom , 
		XtNon , cfg.condition.dont_leave_site ,
		NULL);

	cfg.X.leaved_sw = XtVaCreateManagedWidget("leave_dir" , 
		checkButtonWidgetClass , pom , 
		XtNon , cfg.condition.dont_leave_dir ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("maxd_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.maxdoc_label = XtVaCreateManagedWidget("maxdoc_label" ,
		numberEntryWidgetClass , pom2 ,
		XtNwidth , 70 ,
		XtNvalue , cfg.condition.max_documents ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("maxl_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.maxsize_label = XtVaCreateManagedWidget("maxsize_label" ,
		numberEntryWidgetClass , pom2 ,
		XtNwidth , 70 ,
		XtNvalue , cfg.condition.max_size ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("maxs_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.maxlev_label = XtVaCreateManagedWidget("maxlev_label" ,
		numberEntryWidgetClass , pom2 ,
		XtNwidth , 70 ,
		XtNvalue , cfg.condition.max_levels ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("leavel_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.leave_level = XtVaCreateManagedWidget("leave_level" ,
		numberEntryWidgetClass , pom2 ,
		XtNwidth , 70 ,
		XtNvalue , cfg.condition.leave_level ,
		NULL);


	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("subdir_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.subdir_label = XtVaCreateManagedWidget("subd_label" ,
		entryLineWidgetClass , pom2 ,
		XtNresizable , True ,
		XtNtext , cfg.subdir ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("mpattd_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.pattern_label = XtVaCreateManagedWidget("pattern_label" ,
		entryLineWidgetClass , pom2 ,
		XtNresizable , True ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("url_mpattd_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.url_pattern_label = XtVaCreateManagedWidget("url_pattern_label" ,
		entryLineWidgetClass , pom2 ,
		XtNresizable , True ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("uexit_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.en_uexit = XtVaCreateManagedWidget("en_uexit" ,
		entryLineWidgetClass , pom2 ,
		XtNresizable , True ,
		NULL);

/*** HOSTS ***/
	cpar = XtVaCreateWidget("cfg_lim_row" , rowWidgetClass , cb ,
		XtNbox_width , 3 ,
		XtNbox_type , XtCno_box ,
		XtNheight , 10 ,
		XtNwidth , 10 ,
		XtNassociated_button , blabels[1] , NULL);

	pom = XtVaCreateManagedWidget("dumy_col" , colWidgetClass , cpar ,  
		XtNbox_type , XtCno_box ,
		XtNresizable , True , NULL);

	cfg.X.hosts_sw = XtVaCreateManagedWidget("hosts_sw" , 
		checkButtonWidgetClass , pom , 
		XtNon , cfg.condition.allow_site ,
		NULL);

	cfg.X.hosts_list = GetListWidget(
		XtVaCreateManagedWidget("hosts_list" , scrollListWidgetClass , 
		pom , XtNresizable , True ,
		XtNwidth , 200 ,
		NULL));

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  NULL);

	XtVaCreateManagedWidget("hosts_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.hosts_entry = XtVaCreateManagedWidget("hosts_entry" , entryLineWidgetClass ,
		pom2 ,
		XtNresizable , True ,
		NULL);

	hosts.listw = cfg.X.hosts_list;
	hosts.entryw = cfg.X.hosts_entry;
	hosts.list = & cfg.condition.sites;

	XtAddCallback(cfg.X.hosts_entry , XtNactivate , AppendToList , &hosts);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		NULL);

	but = XtVaCreateManagedWidget("but_append" , buttonWidgetClass , pom2 , 
		XtNleft_space , 15 ,
		XtNgravitation , XtCleft , NULL);

	XtAddCallback(but , XtNactivate , AppendToList , &hosts);

	but = XtVaCreateManagedWidget("but_delete" , buttonWidgetClass , pom2 , 
		XtNright_space , 15 , 
		XtNgravitation , XtCright , NULL);

	XtAddCallback(but , XtNactivate , DeleteFromList , &hosts);

/*** DOMAINS ***/
	pom = XtVaCreateManagedWidget("dumy_col" , colWidgetClass , cpar ,  
		XtNbox_type , XtCno_box ,
		XtNresizable , True , NULL);

	cfg.X.domain_sw = XtVaCreateManagedWidget("domain_sw" , 
		checkButtonWidgetClass , pom , 
		XtNon , cfg.condition.allow_domain ,
		NULL);

	cfg.X.domain_list = GetListWidget(
		XtVaCreateManagedWidget("domain_list" , scrollListWidgetClass , 
		pom , XtNresizable , True ,
		XtNwidth , 200 ,
		NULL));

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  NULL);

	XtVaCreateManagedWidget("domain_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.domain_entry = XtVaCreateManagedWidget("domain_entry" , entryLineWidgetClass ,
		pom2 ,
		XtNresizable , True ,
		NULL);

	domains.listw = cfg.X.domain_list;
	domains.entryw = cfg.X.domain_entry;
	domains.list = &cfg.condition.domains;

	XtAddCallback(cfg.X.domain_entry , XtNactivate , AppendToList , &domains);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		NULL);

	but = XtVaCreateManagedWidget("but_append" , buttonWidgetClass , pom2 , 
		XtNleft_space , 15 ,
		XtNgravitation , XtCleft , NULL);

	XtAddCallback(but , XtNactivate , AppendToList , &domains);

	but = XtVaCreateManagedWidget("but_delete" , buttonWidgetClass , pom2 , 
		XtNright_space , 15 , 
		XtNgravitation , XtCright , NULL);

	XtAddCallback(but , XtNactivate , DeleteFromList , &domains);

/*** DOCUMENTS ***/
	cpar = XtVaCreateWidget("cfg_lim_row" , rowWidgetClass , cb ,
		XtNbox_width , 3 ,
		XtNbox_type , XtCno_box ,
		XtNheight , 10 ,
		XtNwidth , 10 ,
		XtNassociated_button , blabels[2] , NULL);

	pom = XtVaCreateManagedWidget("dumy_col" , colWidgetClass , cpar ,  
		XtNbox_type , XtCno_box ,
		XtNresizable , True , NULL);

	cfg.X.sufix_sw = XtVaCreateManagedWidget("_sfxswitch" , 
		checkButtonWidgetClass , pom , 
		XtNon , cfg.condition.allow_sufix ,
		NULL);

	cfg.X.sufixlist = GetListWidget(
		XtVaCreateManagedWidget("sufix_list" , scrollListWidgetClass , 
		pom , XtNresizable , True ,
		XtNwidth , 200 ,
		NULL));

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  NULL);

	XtVaCreateManagedWidget("sufixd_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.sufix_label = XtVaCreateManagedWidget("sufix_label" , entryLineWidgetClass ,
		pom2 ,
		XtNresizable , True ,
		NULL);

	sfx.listw = cfg.X.sufixlist;
	sfx.entryw = cfg.X.sufix_label;
	sfx.list = & cfg.condition.sufix;

	XtAddCallback(cfg.X.sufix_label , XtNactivate , AppendToList , &sfx);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		NULL);

	but = XtVaCreateManagedWidget("but_append" , buttonWidgetClass , pom2 , 
		XtNleft_space , 15 ,
		XtNgravitation , XtCleft , NULL);

	XtAddCallback(but , XtNactivate , AppendToList , &sfx);

	but = XtVaCreateManagedWidget("but_delete" , buttonWidgetClass , pom2 , 
		XtNright_space , 15 , 
		XtNgravitation , XtCright , NULL);

	XtAddCallback(but , XtNactivate , DeleteFromList , &sfx);

	pom = XtVaCreateManagedWidget("dumy_col" , colWidgetClass , cpar ,  
		XtNbox_type , XtCno_box ,
		XtNresizable , True , NULL);

	cfg.X.prefix_sw = XtVaCreateManagedWidget("_pfxswitch" , 
		checkButtonWidgetClass , pom , 
		XtNon , cfg.condition.allow_prefix ,
		NULL);

	cfg.X.prefixlist = GetListWidget(
		XtVaCreateManagedWidget("prefix_list" , scrollListWidgetClass , 
		pom , XtNresizable , True ,
		XtNwidth , 200 ,
		NULL));

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  NULL);

	XtVaCreateManagedWidget("prefixd_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.prefix_label = XtVaCreateManagedWidget("prefix_label" , entryLineWidgetClass ,
		pom2 ,
		XtNresizable , True ,
		NULL);

	prefix.listw = cfg.X.prefixlist;
	prefix.entryw = cfg.X.prefix_label;
	prefix.list = & cfg.condition.dir_prefix;

	XtAddCallback(cfg.X.prefix_label , XtNactivate , AppendToList , &prefix);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		NULL);

	but = XtVaCreateManagedWidget("but_append" , buttonWidgetClass , pom2 , 
		XtNleft_space , 15 ,
		XtNgravitation , XtCleft , NULL);

	XtAddCallback(but , XtNactivate , AppendToList , &prefix);

	but = XtVaCreateManagedWidget("but_delete" , buttonWidgetClass , pom2 , 
		XtNright_space , 15 , 
		XtNgravitation , XtCright , NULL);

	XtAddCallback(but , XtNactivate , DeleteFromList , &prefix);

/**** MIME Types ****/
	cpar = XtVaCreateWidget("cfg_mime_row" , rowWidgetClass , cb ,
		XtNbox_width , 3 ,
		XtNbox_type , XtCno_box ,
		XtNassociated_button , blabels[3] , NULL);

	pom = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , cpar ,  
		XtNresizable , True , NULL);

	pom2 = XtVaCreateManagedWidget("dumy_col" , colWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.mime_sw = XtVaCreateManagedWidget("mime_sw" , 
		checkButtonWidgetClass , pom2 , 
		XtNon , cfg.condition.allow_mime ,
		NULL);

	cfg.X.amimelist = GetListWidget(
		XtVaCreateManagedWidget("amime_list" , scrollListWidgetClass , 
		pom2 , XtNresizable , True ,
		XtNwidth , 200 ,
		NULL));

	pom2 = XtVaCreateManagedWidget("dumy_col" , colWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		NULL);

	but = XtVaCreateManagedWidget("but_append" , objButtonWidgetClass , pom2 , 
		XtNobj_type , XtCleft_arrow ,
		XtNtop_space , 50 ,
		XtNwidth , 26 , XtNheight , 26 ,
		XtNgravitation , XtCtop , NULL);

	XtAddCallback(but , XtNactivate , AppendToMIMEList , NULL);

	but = XtVaCreateManagedWidget("but_delete" , objButtonWidgetClass , pom2 , 
		XtNobj_type , XtCright_arrow ,
		XtNbottom_space , 50 , 
		XtNwidth , 26 , XtNheight , 26 ,
		XtNgravitation , XtCbottom , NULL);

	XtAddCallback(but , XtNactivate , DeleteFromMIMEList , NULL);

	pom3 = XtVaCreateManagedWidget("dumy_col" , colWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		XtNresizable , True , NULL);

	cfg.X.mimelist = GetListWidget(
		XtVaCreateManagedWidget("mime_list" , scrollListWidgetClass , 
		pom3 , XtNresizable , True ,
		XtNwidth , 200 ,
		NULL));

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom3 ,  NULL);

	XtVaCreateManagedWidget("mimet_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.mimet_entry = XtVaCreateManagedWidget("mimet_entry" , entryLineWidgetClass ,
		pom2 ,
		XtNresizable , True ,
		NULL);

	mimet.listw = cfg.X.amimelist;
	mimet.entryw = cfg.X.mimet_entry;
	mimet.list = & cfg.condition.mime;

	XtAddCallback(cfg.X.mimet_entry , XtNactivate , AppendToList , &mimet);
	XtAddCallback(cfg.X.mimelist , XtNselect_cb , AppendToMIMEList , &mimet);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom3 ,  
		XtNbox_type , XtCno_box ,
		NULL);

	but = XtVaCreateManagedWidget("but_append" , buttonWidgetClass , pom2 , 
		XtNleft_space , 15 ,
		XtNgravitation , XtCleft , NULL);

	XtAddCallback(but , XtNactivate , AppendToList , &mimet);

	but = XtVaCreateManagedWidget("but_delete" , buttonWidgetClass , pom2 , 
		XtNright_space , 15 , 
		XtNgravitation , XtCright , NULL);

	XtAddCallback(but , XtNactivate , DeleteFromList , &mimet);

/**** TIME ****/
	cpar = XtVaCreateWidget("cfg_time_row" , rowWidgetClass , cb ,
		XtNbox_width , 3 ,
		XtNbox_type , XtCno_box ,
		XtNassociated_button , blabels[4] , NULL);

	pom = time_sel_new(cpar , &cfg.X.btime_cal , &cfg.X.btime_h_entry ,
		&cfg.X.btime_min_entry ,
		&cfg.X.btime_mon , &cfg.X.btime_yentry);

	XtVaSetValues(pom , XtNlabel , gettext("Lower document time limit") ,
		XtNbox_type , XtCframein_box , NULL);

	cfg.X.btime_sw = XtVaCreateManagedWidget("btime_sw" , checkButtonWidgetClass ,
			pom , NULL);

	pom = time_sel_new(cpar , &cfg.X.etime_cal , &cfg.X.etime_h_entry ,
		&cfg.X.etime_min_entry ,
		&cfg.X.etime_mon , &cfg.X.etime_yentry);

	XtVaSetValues(pom , XtNlabel , gettext("Uper document time limit") , 
		XtNbox_type , XtCframein_box , NULL);

	cfg.X.etime_sw = XtVaCreateManagedWidget("etime_sw" , checkButtonWidgetClass ,
			pom , NULL);
/**** HTML ****/
	cpar = XtVaCreateWidget("cfg_html_row" , rowWidgetClass , cb ,
		XtNbox_width , 3 ,
		XtNbox_type , XtCno_box ,
		XtNassociated_button , blabels[5] , NULL);

	cfg.X.html_tags = XtVaCreateManagedWidget("html_tags" , multiColWidgetClass , cpar ,
		XtNlabel , gettext("Select allowed HTML tags and attributes") ,
		XtNresizable , True ,
		XtNbox_type , XtCframein_box ,
		NULL);

	for (i = 0 ; i < NUM_ELEM(linky) ; i++)
	{
		for(j = 0 ; linky[i].attribs[j].attrib ; j++)
		{
			char txt[100];

			sprintf(txt , gettext("%s of %s") ,
				linky[i].attribs[j].attrib , linky[i].tag);

			XtVaCreateManagedWidget("html_tags_sw" , 
				checkButtonWidgetClass , cfg.X.html_tags ,
				XtNlabel , new_string(txt) ,
				XtNuser_data , (XtPointer) &linky[i].attribs[j].stat ,
				NULL);

		}
	}
}

/*** COMMON CFG ***/
static void build_config_comm(parent)
Widget parent;
{
	Widget col,cb,cpar,but,pom,pom2,prow,pcol,pom3,pom4;
	char cpom[10];
	static ListOpRec urls;
	static ListOpRec alang;	
	static ListOpRec domains;
	char *blabels[9];

	blabels[0] = gettext("URL");
	blabels[1] = gettext("Graber");
	blabels[2] = gettext("Net");
	blabels[3] = gettext("Proxy");
	blabels[4] = gettext("Languages");
	blabels[5] = gettext("Auth");
	blabels[6] = gettext("SSL");
	blabels[7] = gettext("Log");
	blabels[8] = gettext("Cookies");

	cfg.X.config_shell = XtVaCreatePopupShell("cfg_shell",
		topLevelShellWidgetClass , parent , NULL);
	
	col = XtVaCreateManagedWidget("cfg_col" , colWidgetClass ,
		cfg.X.config_shell , NULL);	

	cfg.X.cb_comcfg = cb = XtVaCreateManagedWidget("card_box" ,
		cardBoxWidgetClass , col ,
		XtNbutton_labels , blabels , 
		XtNnumber_of_buttons , XtNumber(blabels),
		XtNresizable , True ,
		NULL);

	cpar = XtVaCreateManagedWidget("cfg_brow" , rowWidgetClass , col , NULL);

	but = XtVaCreateManagedWidget("but_ok" , buttonWidgetClass , cpar , 
		XtNleft_space , 15 ,
		XtNgravitation , XtCleft , NULL);

	XtAddCallback(but , XtNactivate , DoConfig , cfg.X.config_shell);

	but = XtVaCreateManagedWidget("but_cancel" , buttonWidgetClass , cpar , 
		XtNright_space , 15 , 
		XtNgravitation , XtCright , NULL);

	XtAddCallback(but , XtNactivate , PopdownW , cfg.X.config_shell);

/**** URL CFG ****/
	cpar = XtVaCreateManagedWidget("cfg_grab_row" , rowWidgetClass , cb ,
		XtNbox_width , 3 ,
		XtNbox_type , XtCno_box ,
		XtNheight , 10 ,
		XtNwidth , 10 ,
		XtNassociated_button , blabels[0] , NULL);

	prow  = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , cpar ,
		XtNresizable , True ,
		XtNbox_type , XtCno_box , NULL);

	pom = XtVaCreateManagedWidget("dumy_col" , colWidgetClass , prow ,
		XtNresizable , True ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.url_list = GetListWidget(
		XtVaCreateManagedWidget("url_list" , scrollListWidgetClass , 
		pom , XtNresizable , True ,
		XtNwidth , 250 ,
		NULL));

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  NULL);

	XtVaCreateManagedWidget("urld_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.url_entry = XtVaCreateManagedWidget("url_label" , entryLineWidgetClass ,
		pom2 , 
		XtNresizable , True ,
		NULL);

	urls.listw = cfg.X.url_list;
	urls.entryw = cfg.X.url_entry;
	urls.list = & cfg.prepurlstr;

	XtAddCallback(cfg.X.url_entry , XtNactivate , AppendToList , &urls);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		NULL);

	but = XtVaCreateManagedWidget("but_append" , buttonWidgetClass , pom2 , 
		XtNleft_space , 15 ,
		XtNgravitation , XtCleft , NULL);

	XtAddCallback(but , XtNactivate , AppendToList , &urls);

	but = XtVaCreateManagedWidget("but_delete" , buttonWidgetClass , pom2 , 
		XtNright_space , 15 , 
		XtNgravitation , XtCright , NULL);

	XtAddCallback(but , XtNactivate , DeleteFromList , &urls);

/**** GRABER CFG ****/
	cpar = XtVaCreateWidget("cfg_grab_row" , rowWidgetClass , cb ,
		XtNbox_width , 3 ,
		XtNbox_type , XtCno_box ,
		XtNheight , 10 ,
		XtNwidth , 10 ,
		XtNassociated_button , blabels[1] , NULL);

	prow  = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , cpar ,
		XtNresizable , True ,
		XtNbox_type , XtCno_box , NULL);

	pom = XtVaCreateManagedWidget("dumy_col" , colWidgetClass , prow ,
			XtNresizable , True ,
			XtNbox_type , XtCno_box ,
			NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,
		XtNtop_space , 15 ,
		XtNbox_type , XtCno_box , NULL);

	XtVaCreateManagedWidget("cdird_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.cdir_label = XtVaCreateManagedWidget("cache_dir_label" , entryLineWidgetClass ,
		pom2 ,
		XtNresizable , True ,
		XtNwidth , 10,
		XtNtext , cfg.cache_dir ,
		NULL);

#ifdef WITH_TREE
	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,
		XtNbox_type , XtCno_box , NULL);

	XtVaCreateManagedWidget("browserd_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.browser_label = XtVaCreateManagedWidget("browser_label" , 
		entryLineWidgetClass , pom2 , 
		XtNresizable , True ,
		XtNtext , cfg.browser ,
		NULL);
#endif

	prow =	XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,
		XtNbox_type , XtCno_box , NULL);

	pcol = XtVaCreateManagedWidget("dumy_col" , colWidgetClass , prow ,
			XtNresizable , True ,
			XtNbox_type ,  XtCframein_box ,
			NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pcol ,
		XtNbox_type , XtCno_box , NULL);


	XtVaCreateManagedWidget("retryd_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.retry_label = XtVaCreateManagedWidget("retry_label" ,
		numberEntryWidgetClass , pom2 ,
		XtNwidth , 50,
		XtNvalue , cfg.nretry ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pcol ,
		XtNbox_type , XtCno_box , NULL);

	XtVaCreateManagedWidget("redird_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.redir_label = XtVaCreateManagedWidget("redir_label" ,
		numberEntryWidgetClass , pom2 ,
		XtNwidth , 50,
		XtNvalue , cfg.nredir ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pcol ,
		XtNbox_type , XtCno_box , NULL);

	XtVaCreateManagedWidget("regetd_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.reget_label = XtVaCreateManagedWidget("reget_label" ,
		numberEntryWidgetClass , pom2 ,
		XtNwidth , 50,
		XtNvalue , cfg.nreget ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pcol ,
		XtNbox_type , XtCno_box , NULL);

	XtVaCreateManagedWidget("sleep_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.sleep_label = XtVaCreateManagedWidget("sleepd_label" ,
		numberEntryWidgetClass , pom2 ,
		XtNwidth , 50,
		XtNvalue , cfg.sleep ,
		NULL);

	XtVaCreateManagedWidget("secd_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box , XtNlabel , "s " ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pcol ,
		XtNbox_type , XtCno_box , NULL);

	XtVaCreateManagedWidget("sync_days_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.ddays_label = XtVaCreateManagedWidget("ddays_label" ,
		numberEntryWidgetClass , pom2 ,
		XtNwidth , 50,
		XtNvalue , cfg.ddays ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pcol ,
		XtNbox_type , XtCno_box , NULL);

	XtVaCreateManagedWidget("base_level_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.base_level_label = XtVaCreateManagedWidget("base_level_label" ,
		numberEntryWidgetClass , pom2 ,
		XtNwidth , 50,
		XtNvalue , cfg.base_level ,
		NULL);

/* * */
	pcol = XtVaCreateManagedWidget("dumy_col" , colWidgetClass , prow ,
			XtNresizable , True ,
			XtNbox_type , XtCframein_box ,
			NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pcol ,
		XtNbox_type , XtCno_box , NULL);

	XtVaCreateManagedWidget("sync_rollback_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.rollback_label = XtVaCreateManagedWidget("rollback_label" ,
		numberEntryWidgetClass , pom2 ,
		XtNwidth , 90,
		XtNvalue , cfg.rollback ,
		NULL);	

	cfg.X.freget_sw = XtVaCreateManagedWidget("freget_sw" ,
		checkButtonWidgetClass , pcol ,
		XtNon , cfg.freget ,
		NULL);

	cfg.X.noreloc_sw = XtVaCreateManagedWidget("reloc_sw" ,
		checkButtonWidgetClass , pcol ,
		XtNon , cfg.rewrite_links ,
		NULL);

	cfg.X.enc_sw = XtVaCreateManagedWidget("enc_switch" , 
		checkButtonWidgetClass , pcol , 
		XtNon , cfg.use_enc ,
		NULL);

	cfg.X.oldrm_sw = XtVaCreateManagedWidget("oldrm_switch" , 
		checkButtonWidgetClass , pcol , 
		XtNon , cfg.remove_old ,
		NULL);

	cfg.X.ptime = XtVaCreateManagedWidget("preserve_time" , 
		checkButtonWidgetClass , pcol , 
		XtNon , cfg.preserve_time ,
		NULL);

/**** NET CFG ****/
	cpar = XtVaCreateWidget("cfg_net_col" , colWidgetClass , cb ,
		XtNbox_width , 3 ,
		XtNbox_type , XtCno_box ,
		XtNheight , 100 ,
		XtNwidth , 100 ,
		XtNassociated_button , blabels[2] , NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , cpar ,  
		XtNbox_type , XtCno_box ,
		XtNtop_space , 15 ,
		XtNresizable , True ,
		NULL);

	pom3 = XtVaCreateManagedWidget("dumy_col" , colWidgetClass , pom2 ,  
		XtNbox_type , XtCno_box ,
		XtNresizable , False ,
		NULL);

	prow = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom3 ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("timeoutd_label" , labelWidgetClass , prow ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.timeout_label = XtVaCreateManagedWidget("timeout_label" ,
		numberEntryWidgetClass , prow ,
		XtNwidth , 60 ,
		XtNvalue , cfg.ctimeout ,
		NULL);

	XtVaCreateManagedWidget("secd_label" , labelWidgetClass , prow ,
		XtNbox_type , XtCno_box ,
		NULL);

	prow = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom3 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.cache_sw = XtVaCreateManagedWidget("cache_sw" , 
		checkButtonWidgetClass , prow , 
		XtNon , cfg.cache ,
		NULL);
		
	pom = XtVaCreateManagedWidget("proto_col" , multiColWidgetClass , pom3 ,
		XtNresizable , False ,
		XtNbox_type , XtCframein_box ,
		NULL);

	cfg.X.http_sw = XtVaCreateManagedWidget("http_switch" , 
		checkButtonWidgetClass , pom , 
		XtNon , cfg.condition.http ,
		XtNresizable , True ,
		NULL);

#ifdef USE_SSL
	cfg.X.https_sw = XtVaCreateManagedWidget("https_switch" , 
		checkButtonWidgetClass , pom , 
		XtNon , cfg.condition.https ,
		NULL);
#endif

	cfg.X.ftp_sw = XtVaCreateManagedWidget("ftp_switch" , 
		checkButtonWidgetClass , pom , 
		XtNon , cfg.condition.ftp ,
		NULL);

	cfg.X.gopher_sw = XtVaCreateManagedWidget("gopher_switch" , 
		checkButtonWidgetClass , pom , 
		XtNon , cfg.condition.gopher ,
		NULL);

	cfg.X.ftp_data_sw = XtVaCreateManagedWidget("ftp_data_sw" , radioGroupWidgetClass ,
		pom3 , XtNbox_type , XtCframeout_box , XtNjustify , XtCleft , NULL);

	XtVaCreateManagedWidget("ftp_actived" , checkButtonWidgetClass , cfg.X.ftp_data_sw ,
		XtNon , cfg.ftp_activec , XtNid , 1 ,
		NULL);

	XtVaCreateManagedWidget("ftp_passived" , checkButtonWidgetClass , cfg.X.ftp_data_sw , 
		XtNon , !cfg.ftp_activec , XtNid , 0 ,
		NULL);


/**** PROXY CFG ****/
	cpar = XtVaCreateWidget("cfg_proxy_col" , colWidgetClass , cb ,
		XtNbox_width , 3 ,
		XtNbox_type , XtCno_box ,
		XtNheight , 100 ,
		XtNwidth , 100 ,
		XtNassociated_button , blabels[3] , NULL);

	pom4 = pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , cpar ,  
		XtNtop_space , 10 ,
		XtNbox_type , XtCno_box ,
		XtNhomogenous , TRUE ,
		NULL);

	pom3 = XtVaCreateManagedWidget("httpp_col" , colWidgetClass , pom2 ,  
		XtNbox_type , XtCframein_box ,
		XtNresizable , True ,
		NULL);

	prow = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom3 ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("host_label" , labelWidgetClass , prow ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.http_proxyh_label = XtVaCreateManagedWidget("http_proxy_label" , entryLineWidgetClass ,
		prow ,
		XtNresizable , True ,
		XtNtext , cfg.http_proxy ,
		NULL);

	prow = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom3 ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("port_label" , labelWidgetClass , prow ,
		XtNbox_type , XtCno_box ,
		NULL);

	sprintf(cpom,"%d",cfg.http_proxy_port);

	cfg.X.http_proxyp_label = XtVaCreateManagedWidget("http_port_label" , entryLineWidgetClass ,
		prow ,
		XtNresizable , True ,
		XtNtext , cpom ,
		NULL);

#ifdef USE_SSL
	pom3 = XtVaCreateManagedWidget("sslp_col" , colWidgetClass , pom2 ,  
		XtNbox_type , XtCframein_box ,
		XtNresizable , True ,
		NULL);


	prow = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom3 ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("host_label" , labelWidgetClass , prow ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.ssl_proxyh_label = XtVaCreateManagedWidget("ssl_proxy_label" , entryLineWidgetClass ,
		prow ,
		XtNresizable , True ,
		XtNtext , cfg.ssl_proxy ,
		NULL);

	prow = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom3 ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("port_label" , labelWidgetClass , prow ,
		XtNbox_type , XtCno_box ,
		NULL);

	sprintf(cpom,"%d",cfg.ssl_proxy_port);

	cfg.X.ssl_proxyp_label = XtVaCreateManagedWidget("ssl_port_label" , entryLineWidgetClass ,
		prow ,
		XtNresizable , True ,
		XtNtext , cpom ,
		NULL);
#endif


	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , cpar ,  
		XtNtop_space , 10 ,
		XtNbox_type , XtCno_box ,
		XtNhomogenous , TRUE ,
		NULL);

	pom3 = XtVaCreateManagedWidget("gopherp_col" , colWidgetClass , pom2 ,  
		XtNbox_type , XtCframein_box ,
		XtNresizable , True ,
		NULL);

	prow = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom3 ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("host_label" , labelWidgetClass , prow ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.gopher_proxyh_label = XtVaCreateManagedWidget("gopher_host_label" , entryLineWidgetClass ,
		prow ,
		XtNresizable , True ,
		XtNtext , cfg.gopher_proxy ,
		NULL);

	prow = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom3 ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("port_label" , labelWidgetClass , prow ,
		XtNbox_type , XtCno_box ,
		NULL);

	sprintf(cpom,"%d",cfg.gopher_proxy_port);

	cfg.X.gopher_proxyp_label = XtVaCreateManagedWidget("gopher_port_label" , entryLineWidgetClass ,
		prow ,
		XtNresizable , True ,
		XtNtext , cpom ,
		NULL);

	cfg.X.gopher_httpgw = XtVaCreateManagedWidget("gopher_httpgw_label" , 
		checkButtonWidgetClass , pom3 ,
		XtNon , cfg.gopher_via_http ,
		NULL);

	pom3 = XtVaCreateManagedWidget("ftpp_col" , colWidgetClass , pom2 ,  
		XtNbox_type , XtCframein_box ,
		XtNresizable , True ,
		NULL);

	prow = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom3 ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("host_label" , labelWidgetClass , prow ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.ftp_proxyh_label = XtVaCreateManagedWidget("ftp_proxy_label" , entryLineWidgetClass ,
		prow ,
		XtNresizable , True ,
		XtNtext , cfg.ftp_proxy ,
		NULL);

	prow = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom3 ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("port_label" , labelWidgetClass , prow ,
		XtNbox_type , XtCno_box ,
		NULL);

	sprintf(cpom,"%d",cfg.ftp_proxy_port);

	cfg.X.ftp_proxyp_label = XtVaCreateManagedWidget("ftp_port_label" , entryLineWidgetClass ,
		prow ,
		XtNresizable , True ,
		XtNtext , cpom ,
		NULL);

	cfg.X.ftp_httpgw = XtVaCreateManagedWidget("ftp_httpgw_label" , 
		checkButtonWidgetClass , pom3 ,
		XtNon , cfg.ftp_via_http ,
		NULL);


	cfg.X.ftp_dirtyp = XtVaCreateManagedWidget("ftp_dirtyp_label" , 
		checkButtonWidgetClass , pom3 ,
		XtNon , cfg.ftp_dirtyp ,
		NULL);

/**** LANGUAGES ****/
	cpar = XtVaCreateWidget("cfg_lang_row" , rowWidgetClass , cb ,
		XtNbox_width , 3 ,
		XtNbox_type , XtCno_box ,
		XtNassociated_button , blabels[4] , NULL);

	pom = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , cpar ,  
		XtNtop_space , 15 ,
		XtNresizable , True , NULL);

	cfg.X.langlist = GetListWidget(
		XtVaCreateManagedWidget("lang_list" , scrollListWidgetClass , 
		pom , XtNresizable , True ,
		XtNwidth , 200 ,
		NULL));

	pom2 = XtVaCreateManagedWidget("dumy_col" , colWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		NULL);

	but = XtVaCreateManagedWidget("but_append" , objButtonWidgetClass , pom2 , 
		XtNobj_type , XtCleft_arrow ,
		XtNtop_space , 50 ,
		XtNwidth , 26 , XtNheight , 26 ,
		XtNgravitation , XtCtop , NULL);

	XtAddCallback(but , XtNactivate , AppendToLangList , NULL);

	but = XtVaCreateManagedWidget("but_delete" , objButtonWidgetClass , pom2 , 
		XtNobj_type , XtCright_arrow ,
		XtNbottom_space , 50 , 
		XtNwidth , 26 , XtNheight , 26 ,
		XtNgravitation , XtCbottom , NULL);

	XtAddCallback(but , XtNactivate , DeleteFromLangList , NULL);

	pom3 = XtVaCreateManagedWidget("dumy_col" , colWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		XtNresizable , True , NULL);

	cfg.X.alanglist = GetListWidget(
		XtVaCreateManagedWidget("alang_list" , scrollListWidgetClass , 
		pom3 , XtNresizable , True ,
		XtNwidth , 200 ,
		NULL));

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom3 ,  NULL);

	XtVaCreateManagedWidget("alang_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.alang_entry = XtVaCreateManagedWidget("mimet_entry" , entryLineWidgetClass ,
		pom2 ,
		XtNresizable , True ,
		NULL);

	alang.listw = cfg.X.langlist;
	alang.entryw = cfg.X.alang_entry;
	alang.list = & cfg.accept_lang;;

	XtAddCallback(cfg.X.alang_entry , XtNactivate , AppendToList , &alang);
	XtAddCallback(cfg.X.alanglist , XtNselect_cb , AppendToLangList , &alang);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom3 ,  
		XtNbox_type , XtCno_box ,
		NULL);

	but = XtVaCreateManagedWidget("but_append" , buttonWidgetClass , pom2 , 
		XtNleft_space , 15 ,
		XtNgravitation , XtCleft , NULL);

	XtAddCallback(but , XtNactivate , AppendToList , &alang);

	but = XtVaCreateManagedWidget("but_delete" , buttonWidgetClass , pom2 , 
		XtNright_space , 15 , 
		XtNgravitation , XtCright , NULL);

	XtAddCallback(but , XtNactivate , DeleteFromList , &alang);

/**** AUTH CFG ****/
	cpar = XtVaCreateWidget("cfg_auth_col" , colWidgetClass , cb ,
		XtNbox_width , 3 ,
		XtNbox_type , XtCno_box ,
		XtNheight , 10 ,
		XtNwidth , 10 ,
		XtNassociated_button , blabels[5] , NULL);

	pom = XtVaCreateManagedWidget("authl_label" , rowWidgetClass , cpar ,
		XtNtop_space , 15 ,
		XtNbox_type , XtCframeout_box ,
		NULL);

	pom3 =  XtVaCreateManagedWidget("dumy_col" , colWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		XtNresizable , True ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom3 , 
		XtNbox_width , 0 ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("authd_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.auth_label = XtVaCreateManagedWidget("auth_label" , entryLineWidgetClass ,
		pom2 ,
		XtNresizable , True ,
		XtNtext , cfg.name_auth ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom3 , 
		XtNbox_width , 0 ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("passd_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.pass_label = XtVaCreateManagedWidget("pass_label" , entryLineWidgetClass ,
		pom2 ,
		XtNresizable , True ,
		XtNtext , cfg.passwd_auth ,
		XtNecho , False ,
		NULL);

	cfg.X.auth_sw = XtVaCreateManagedWidget("auth_box" , radioGroupWidgetClass ,
		pom , XtNbox_type , XtCframeout_box , XtNjustify , XtCleft , NULL);

	XtVaCreateManagedWidget("auth_user" , checkButtonWidgetClass , cfg.X.auth_sw ,
		XtNon , (cfg.auth_scheme == 1) , XtNid , 1 ,
		NULL);

	XtVaCreateManagedWidget("auth_base" , checkButtonWidgetClass , cfg.X.auth_sw , 
		XtNon , (cfg.auth_scheme == 2) , XtNid , 2 ,
		NULL);

	XtVaCreateManagedWidget("auth_digest" , checkButtonWidgetClass ,
		cfg.X.auth_sw , 
		XtNon , (cfg.auth_scheme == 3) , XtNid , 3 ,
		NULL);

/*** HTTP proxy auth ***/
	pom = XtVaCreateManagedWidget("proxy_authl_label" , rowWidgetClass , cpar ,
		XtNbox_type , XtCframeout_box ,
		NULL);

	pom3 =  XtVaCreateManagedWidget("dumy_col" , colWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		XtNresizable , True ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom3 , 
		XtNbox_width , 0 ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("proxy_authd_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.proxy_auth_label = XtVaCreateManagedWidget("proxy_auth_label" , 
		entryLineWidgetClass , pom2 ,
		XtNresizable , True ,
		XtNtext , cfg.http_proxy_user ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom3 , 
		XtNbox_width , 0 ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("proxy_passd_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.proxy_pass_label = XtVaCreateManagedWidget("proxy_pass_label" , entryLineWidgetClass ,
		pom2 ,
		XtNresizable , True ,
		XtNtext , cfg.http_proxy_pass ,
		XtNecho , False ,
		NULL);

	cfg.X.proxy_auth_sw = XtVaCreateManagedWidget("proxy_auth_box" , radioGroupWidgetClass ,
		pom , XtNbox_type , XtCframeout_box , XtNjustify , XtCleft , NULL);

	XtVaCreateManagedWidget("proxy_auth_user" , checkButtonWidgetClass ,
		cfg.X.proxy_auth_sw ,
		XtNon , (cfg.proxy_auth_scheme == 1) , XtNid , 1 ,
		NULL);

	XtVaCreateManagedWidget("proxy_auth_base" , checkButtonWidgetClass ,
		cfg.X.proxy_auth_sw , 
		XtNon , (cfg.proxy_auth_scheme == 2) , XtNid , 2 ,
		NULL);


/* auth file */

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , cpar , 
		XtNbox_width , 0 ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("auth_file_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.auth_file_label = XtVaCreateManagedWidget("auth_file_label" , entryLineWidgetClass ,
		pom2 ,
		XtNresizable , True ,
		XtNtext , cfg.auth_file ,
		NULL);

/* from */
	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , cpar , 
		XtNbox_width , 0 ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("fromd_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.from_label = XtVaCreateManagedWidget("from_label" , entryLineWidgetClass ,
		pom2 ,
		XtNresizable , True ,
		XtNtext , cfg.from ,
		NULL);

/*** SSL ***/
#ifdef USE_SSL
	cpar = XtVaCreateManagedWidget("cfg_ssl_col" , colWidgetClass , cb ,
		XtNbox_width , 3 ,
		XtNbox_type , XtCno_box ,
		XtNheight , 10 ,
		XtNwidth , 10 ,
		XtNassociated_button , blabels[6] , NULL);

	pom = XtVaCreateManagedWidget("dumy_col" , colWidgetClass , cpar , 
		XtNlabel , gettext("SSL client certificate") ,
		XtNbox_type , XtCframeout_box ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom , 
		XtNbox_width , 0 ,
		XtNbox_type , XtCno_box ,
		XtNresizable, False ,
		NULL);

	XtVaCreateManagedWidget("ssl_cert_passwd_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.ssl_cert_passwd_en = XtVaCreateManagedWidget("ssl_cert_passwd_en" , entryLineWidgetClass ,
		pom2 ,
		XtNresizable , True ,
		XtNtext , cfg.from ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom , 
		XtNbox_width , 0 ,
		XtNbox_type , XtCno_box ,
		XtNresizable, False ,
		NULL);

	XtVaCreateManagedWidget("ssl_cert_file_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.ssl_cert_file_en = XtVaCreateManagedWidget("ssl_cert_file_en" , entryLineWidgetClass ,
		pom2 ,
		XtNresizable , True ,
		XtNtext , cfg.from ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom , 
		XtNbox_width , 0 ,
		XtNbox_type , XtCno_box ,
		XtNresizable, False ,
		NULL);

	XtVaCreateManagedWidget("ssl_key_file_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.ssl_key_file_en = XtVaCreateManagedWidget("ssl_key_file_en" , entryLineWidgetClass ,
		pom2 ,
		XtNresizable , True ,
		XtNtext , cfg.from ,
		NULL);

#endif

/*** LOG ***/
	cpar = XtVaCreateWidget("cfg_log_row" , rowWidgetClass , cb ,
		XtNbox_width , 3 ,
		XtNbox_type , XtCno_box ,
		XtNheight , 10 ,
		XtNwidth , 10 ,
		XtNassociated_button , blabels[7] , NULL);

	pom =  XtVaCreateManagedWidget("dumy_col" , colWidgetClass , cpar ,  
		XtNbox_type , XtCno_box ,
		XtNresizable , True ,
		NULL);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom , 
		XtNbox_width , 0 ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("log_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.log_label = XtVaCreateManagedWidget("log_label" , 
		entryLineWidgetClass , pom2 ,
		XtNresizable , True ,
		XtNtext , cfg.logfile ,
		NULL);

/*
	but = XtVaCreateManagedWidget("but_browse" , buttonWidgetClass , pom2 , 
		XtNleft_space , 10 ,
		XtNgravitation , XtCleft , NULL);

	XtAddCallback(but , XtNactivate , PopupW , (XtPointer) fss);
*/

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom , 
		XtNbox_width , 0 ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("xloglen_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.xloglen_label = XtVaCreateManagedWidget("xloglen_label" , 
		numberEntryWidgetClass , pom2 ,
		XtNwidth , 50,
		XtNvalue , cfg.xlogsize ,
		NULL);

/**** COOKIES CFG ****/
	cpar = XtVaCreateWidget("cfg_cookies_row" , rowWidgetClass , cb ,
		XtNbox_width , 3 ,
		XtNbox_type , XtCno_box ,
		XtNheight , 100 ,
		XtNwidth , 100 ,
		XtNassociated_button , blabels[8] , NULL);

	pom = XtVaCreateManagedWidget("dumy_col" , colWidgetClass , cpar ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.sw_cookie_update = XtVaCreateManagedWidget("sw_cookie_update" , 
		checkButtonWidgetClass , pom , 
		XtNon , cfg.update_cookies ,
		NULL);

	cfg.X.sw_cookie_send = XtVaCreateManagedWidget("sw_cookie_send" , 
		checkButtonWidgetClass , pom , 
		XtNon , cfg.send_cookies ,
		NULL);

	cfg.X.sw_cookie_recv = XtVaCreateManagedWidget("sw_cookie_recv" , 
		checkButtonWidgetClass , pom , 
		XtNon , cfg.recv_cookies ,
		NULL);

	prow = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("maxcookie_label" , labelWidgetClass , prow ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.en_cookie_max = XtVaCreateManagedWidget("maxcookie_label" ,
		numberEntryWidgetClass , prow ,
		XtNwidth , 80 ,
		XtNvalue , cfg.cookies_max ,
		NULL);

	prow = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom , 
		XtNbox_width , 0 ,
		XtNbox_type , XtCno_box ,
		NULL);

	XtVaCreateManagedWidget("en_cookie_file" , labelWidgetClass , prow ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.en_cookie_file = XtVaCreateManagedWidget("en_cookie_file_" , 
		entryLineWidgetClass , prow ,
		XtNresizable , True ,
		XtNtext , cfg.cookie_file ,
		NULL);


	pom = XtVaCreateManagedWidget("dumy_col" , colWidgetClass , cpar ,  
		XtNbox_type , XtCno_box ,
		XtNlabel , gettext("Disabled cookie domains") ,
		XtNresizable , True , NULL);

	cfg.X.cookie_domain_list = GetListWidget(
		XtVaCreateManagedWidget("hosts_list" , scrollListWidgetClass , 
		pom , XtNresizable , True ,
		XtNwidth , 200 ,
		NULL));

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  NULL);

	XtVaCreateManagedWidget("domain_label" , labelWidgetClass , pom2 ,
		XtNbox_type , XtCno_box ,
		NULL);

	cfg.X.cookie_domain_entry = XtVaCreateManagedWidget("domains_entry" , entryLineWidgetClass ,
		pom2 ,
		XtNresizable , True ,
		NULL);

	domains.listw = cfg.X.cookie_domain_list;
	domains.entryw = cfg.X.cookie_domain_entry;
	domains.list = & cfg.cookies_disabled_domains;

	XtAddCallback(cfg.X.cookie_domain_entry , XtNactivate , AppendToList , &domains);

	pom2 = XtVaCreateManagedWidget("dumy_row" , rowWidgetClass , pom ,  
		XtNbox_type , XtCno_box ,
		NULL);

	but = XtVaCreateManagedWidget("but_append" , buttonWidgetClass , pom2 , 
		XtNleft_space , 15 ,
		XtNgravitation , XtCleft , NULL);

	XtAddCallback(but , XtNactivate , AppendToList , &domains);

	but = XtVaCreateManagedWidget("but_delete" , buttonWidgetClass , pom2 , 
		XtNright_space , 15 , 
		XtNgravitation , XtCright , NULL);

	XtAddCallback(but , XtNactivate , DeleteFromList , &domains);

}

static void build_toolbar(parent)
Widget parent;
{
	Widget row;
	Icon *icona;

	row =  XtVaCreateManagedWidget("tool_row" , rowWidgetClass , parent , 
			XtNbox_width , 0 ,
			XtNbox_type , XtCno_box , NULL);

	icona = X_XpmDataToIcon(cfg.X.dpy , cfg2);

	cfg.X.bt_cfg = XtVaCreateManagedWidget("tool_config" , menuButtonWidgetClass , row ,
		XtNicon , icona , XtNmenu_name , "menu_cfg" , NULL);

	icona = X_XpmDataToIcon(cfg.X.dpy , killi);

	cfg.X.bt_exit = XtVaCreateManagedWidget("tool_exit" , buttonWidgetClass , row , 
		XtNgravitation , XtCright , XtNicon , icona , NULL);	

	XtAddCallback(cfg.X.bt_exit , XtNactivate , Quit , NULL);

	icona = X_XpmDataToIcon(cfg.X.dpy , brkx);

	cfg.X.bt_break = XtVaCreateManagedWidget("tool_break" , buttonWidgetClass , row , 
		XtNgravitation , XtCright , XtNicon , icona , NULL);	

	XtAddCallback(cfg.X.bt_break , XtNactivate , Break , NULL);

	XtSetSensitive(cfg.X.bt_break , FALSE);

	icona = X_XpmDataToIcon(cfg.X.dpy , stop);

	cfg.X.bt_stop = XtVaCreateManagedWidget("tool_stop" , buttonWidgetClass , row , 
		XtNgravitation , XtCright , XtNicon , icona , NULL);	

	XtAddCallback(cfg.X.bt_stop , XtNactivate , Stop , NULL);

	XtSetSensitive(cfg.X.bt_stop , FALSE);

	icona = X_XpmDataToIcon(cfg.X.dpy , sema);

	cfg.X.bt_start = XtVaCreateManagedWidget("tool_start" , buttonWidgetClass , row , 
		XtNgravitation , XtCright , XtNicon , icona ,  NULL);	
		
	XtSetSensitive(cfg.X.bt_start,FALSE);

	XtAddCallback(cfg.X.bt_start , XtNactivate , Start , FALSE);

	icona = X_XpmDataToIcon(cfg.X.dpy , rest);

	cfg.X.bt_rest = XtVaCreateManagedWidget("tool_restart" , buttonWidgetClass , row , 
		XtNgravitation , XtCright , XtNicon , icona ,  NULL);	

	XtAddCallback(cfg.X.bt_rest , XtNactivate , Start , (XtPointer)TRUE);

	icona = X_XpmDataToIcon(cfg.X.dpy , backg);

	cfg.X.bt_bg = XtVaCreateManagedWidget("tool_bg" , buttonWidgetClass , row , 
		XtNicon , icona , NULL);

	XtAddCallback(cfg.X.bt_bg , XtNactivate , Gobg , NULL);
}

void build_interface(argc,argv)
int *argc;
char **argv;
{
	char **p;
	int i;
	char pom[1024];
	
	p = (char **) malloc(XtNumber(resource) * sizeof(char *));

	for(i = 0 ; i < XtNumber(resource) ; i++) 
	{
		if (resource[i].atrib) 
			sprintf(pom , "%s %s" ,  resource[i].atrib ?
				resource[i].atrib : ""  ,
				resource[i].translatable ? gettext(resource[i].tstr) :
				resource[i].tstr);

		p[i] = resource[i].atrib ? XtNewString(pom) : NULL;
	}

	if (cfg.fontname)
	{
		sprintf(pom , "*.Font: %s" , cfg.fontname);
		p[i - 2] = XtNewString(pom);
		p[i - 1] = NULL;
	}

        cfg.X.toplevel = XtVaAppInitialize
                (&(cfg.X.app_context) , "Pavuk", NULL, 0, argc, argv, p , NULL);

	for(i = 0 ; i < XtNumber(resource) ; i++) 
		XtFree(p[i]);

	XtFree((char *)p);
}

void iface_loop()
{
	Widget col,swin;
	ListStruct plist;
	char **p;

	cfg.done = FALSE;


	col = XtVaCreateManagedWidget("top_col" , colWidgetClass , cfg.X.toplevel , NULL);

	cfg.X.dpy = XtDisplay(col);

	build_about(cfg.X.toplevel);
	build_config_comm(cfg.X.toplevel);
	build_config_sch(cfg.X.toplevel);
	build_config_lim(cfg.X.toplevel);
	build_tree_preview(cfg.X.toplevel);
	build_scenario_loader(cfg.X.toplevel);
	build_scenario_saver(cfg.X.toplevel);
	build_menu(col);
	build_toolbar(col);

	swin = XtVaCreateManagedWidget("swin" , scrollWinWidgetClass ,
		col , XtNresizable , True , NULL);

	cfg.X.logw = XtVaCreateManagedWidget("log" , logWidgetClass ,
		swin , XtNmaxlines , cfg.xlogsize , 
		XtNresizable , True , XtNbottom_grav , True , NULL);

	col = XtVaCreateManagedWidget("dummy_row" , rowWidgetClass , col, 
			XtNbox_width , 0 ,
			XtNgravitation , XtCbottom ,
			XtNbox_type , XtCno_box , NULL);

	cfg.X.what_widget = XtVaCreateManagedWidget("help_label" , labelWidgetClass , col , 
		XtNspacing , 2 ,
		XtNresizable , True , NULL);

	cfg.X.size_widget = XtVaCreateManagedWidget("size_label" , labelWidgetClass , col ,
		XtNspacing , 2 ,
		XtNwidth , 150 , NULL);

	cfg.X.cnt_widget = XtVaCreateManagedWidget("cnt_label" , labelWidgetClass , col , 
		XtNspacing , 2 ,
		XtNwidth , 90 , NULL);

	icons_load();
	
        XtRealizeWidget(cfg.X.toplevel);

	xset_cfg_values_comm();
	xset_cfg_values_lim();

       	plist.sensitive = True;
  	plist.left_icon = NULL;
  	plist.right_icon = NULL;
  	plist.related_info = NULL;

	p = iso_lang;
	ListChange(cfg.X.alanglist , NULL , 0 , True);
        if (p) while(*p)
        {
        	plist.label = *p;
  		ListAppendItems(cfg.X.alanglist , &plist , 1);
  		p++;
	}

	p = mimetypes;
	ListChange(cfg.X.mimelist , NULL , 0 , True);
        if (p) while(*p)
        {
        	plist.label = *p;
  		ListAppendItems(cfg.X.mimelist , &plist , 1);
  		p++;
	}

	cfg.done = TRUE;

	while (cfg.xi_face)
	{
                XEvent event;
                XtAppNextEvent(cfg.X.app_context , &event);
                XtDispatchEvent(&event);
	}

	if (cfg.mode != cfg.prev_mode || !cfg.mode_started)
	{	
		absi_restart();
	}
	else
	{
		absi_cont();
	}
}

void iface_set_counter(text)
char *text;
{
	LabelSetLabel(cfg.X.cnt_widget , text);
}

void iface_set_size(sz)
int sz;
{
	char pom[40];

	if (cfg.totsz) sprintf(pom , "%d / %d" , sz ,cfg.totsz);
	else sprintf(pom , "%d" , sz);
	LabelSetLabel(cfg.X.size_widget , pom);
}

void iface_set_what(text)
char *text;
{
	LabelSetLabel(cfg.X.what_widget , text);

	_Xt_Serve
}


#ifdef WITH_TREE
TreeList * iface_make_tree_entry(urlp)
url *urlp;
{
	TreeList *retv;
	TreeListItem i_nfo;
	char *p;

	p = url_to_urlstr(urlp);
	i_nfo.label = p;
	i_nfo.id = 0;

	if (urlp->status & URL_PROCESSED)
	{
		i_nfo.icon = urlp->tree_nfo[0]->item->icon;
	}
	else
	{
		i_nfo.icon = cfg.icon.notprocessed;
	}
	
	retv = TreeListInsertItem(
			cfg.X.tree_widget , 
			urlp->parent_url[urlp->ref_cnt-1] ? urlp->parent_url[urlp->ref_cnt-1]->tree_nfo[0] : cfg.X.root , 
			&i_nfo);

	free(p);
	retv->item->related_info = urlp;
	retv->managed = TRUE;

	return retv;
}
#endif


#endif /* X_FACE */
